
Version 1.20.1 released
=======================

	`gnu.png' isn't needed any more.

	* doc/Makefile.in: Don't handle or create `gnu.png'.
	Update all affected targets.

	* doc/Makefile.sub: Don't handle or create `gnu.png'.
	Update alll affected targets.


	`gnu.eps' was missing in the tarball.
	Problem reported by Patrik Gräser.

	(PROCESSEDEXAMPLEFILES): Remove `gnu.eps'.
	(MOSTLYCLEANNOTSRCDIRADD): Fix names of info files.
	(install_data): Handle `gnu.eps' specially.

	* MORE.STUFF: Mention texi2html's troff backend.
	Mention http://groff.ffii.org/groff/contrib.

	* README: Mention `MORE.STUFF'.

	* NEWS, doc/webpage.ms, doc/groff.texinfo: Updated.

2009-01-08  Werner LEMBERG  <wl@gnu.org>

	* */Makefile.* (CLEANADD, CLEANNOTSRCDIRADD, CLEANDIRADD): Renamed
	to...
	(MOSTLYCLEANADD, MOSTLYCLEANNOTSRCDIRADD, MOSTLYCLEANDIRADD): This.

2009-01-06  Werner LEMBERG  <wl@gnu.org>

	Remove heuristics for LIBEXT.

	* configure.ac: Provide LIBEXT.	
	* Makefile.in: Use it.

	* configure: Regenerated.

2009-01-05  Werner LEMBERG  <wl@gnu.org>

Version 1.20 released
=====================

2009-01-05  Werner LEMBERG  <wl@gnu.org>

	* */*: Update FDL 1.1 to FDL 1.3.

2009-01-05  Werner LEMBERG  <wl@gnu.org>

	* */*: Update copyright year.

2009-01-05  Werner LEMBERG  <wl@gnu.org>

	* MANIFEST: Updated.

2009-01-05  Werner LEMBERG  <wl@gnu.org>

	* doc/texinfo.tex (\key): Fix excessive whitespace.
	(\texinfoversion): Tag file as patched.

2009-01-05  Werner LEMBERG  <wl@gnu.org>

	* tmac/s.tmac (@TS, TE, @EQ, @EN), tmac/an-old.tmac (TS, TE, EQ,
	EN), tmac/e.tmac (TS, TE, EQ, EN): Set line length to a large value
	if processed with -Thtml.

2009-01-04  Werner LEMBERG  <wl@gnu.org>

	* tmac/www.tmac (TS, TE, EQ, EN): Set line length to a large value
	if processed with -Thtml to avoid warning messages (from code
	inserted by tbl, for example).

2009-01-04  Gunnar Florus  <http://florus.no>

	* */*: Update GPL2 to GPL3.

2009-01-04  Werner LEMBERG  <wl@gnu.org>

	* Makefile.in (dist): Don't use soft links but copy files to
	preserve the file's time stamps.
	* Makefile.sub (configure): Remove `autom4te.cache'.

2009-01-04  Werner LEMBERG  <wl@gnu.org>

	* tmac/de.tmac: Fix German date strings.  Reported by Axel Kielhorn.

2009-01-04  Werner LEMBERG  <wl@gnu.org>

	* doc/texinfo.tex: Updated from `texinfo' CVS repository.
	* doc/txi-en.tex: New file from `texinfo' CVS repository.

2009-01-04  Werner LEMBERG  <wl@gnu.org>

	* font/make-Rproto: Moved to...
	* font/util/make-Rproto: Here.

	* Makefile.in (NOMAKEDIRS): Add `m4', `font/devps/old', and
	`font/util'.

2009-01-04  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/TODO: Mention local variables.

2009-01-03  Werner LEMBERG  <wl@gnu.org>

	* contrib/hdtbl/examples/col_rowspan_colors.roff,
	contrib/hdtbl/examples/color_boxes.roff,
	contrib/hdtbl/examples/color_nested_tables.roff,
	contrib/hdtbl/examples/color_table_cells.roff,
	contrib/hdtbl/examples/color_transitions.roff,
	contrib/hdtbl/examples/short_reference.roff: Minor improvements.

2009-01-03  Werner LEMBERG  <wl@gnu.org>

	* doc/webpage.ms: Updated.

2009-01-03  Werner LEMBERG  <wl@gnu.org>

	* NEWS, doc/groff.texinfo, font/devps/*, VERSION, REVISION: Prepare
	for version 1.20.

2009-01-03  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/table.cpp (table::compute_expand_width,
	table::compute_separation_factor): In warning messages, don't refer
	to pages but to input line numbers.

2009-01-03  Werner LEMBERG  <wl@gnu.org>

	* tmac/groff_ms.man: Improve formatting of tables.

2009-01-03  Werner LEMBERG  <wl@gnu.org>

	* tmac/www.tmac (www->): Handle XHTML.
	(HTML</p>): Handle non-HTML devices.
	(www:url_check_tag): Avoid warnings.

2009-01-03  Werner LEMBERG  <wl@gnu.org>

	* tmac/an-old.tmac, tmac/doc.tmac: For -Tutf8, map \-, -, ', and `
	conservatively to ASCII for the sake of easy cut and paste.

2009-01-03  Werner LEMBERG  <wl@gnu.org>

	* NEWS: Mention hdtbl.

2009-01-02  Werner LEMBERG  <wl@gnu.org>

	* tmac/groff_mdoc.man: Update OS version string listing.

2009-01-02  Werner LEMBERG  <wl@gnu.org>

	* config.rpath, m4/codeset.m4, m4/glibc21.m4, m4/iconv.m4,
	m4/lib-link.m4, m4/lib-prefix.m4, src/include/localcharset.h,
	src/libs/libgroff/config.charset, src/libs/libgroff/localcharset.c,
	src/libs/libgroff/ref-add.sin, src/libs/libgroff/ref-del.sin:
	Updated from `gnulib' git repository.

	* configure: Regenerated.

2009-01-02  Werner LEMBERG  <wl@gnu.org>

	* tmac/ptx.tmac: New file.

	* NEWS, man/groff_tmac: man: Document it.

2008-12-30  Werner LEMBERG  <wl@gnu.org>

	Fix more quoting issues.

	* tmac/www.tmac (BCL, BGIMG, PIMG, MPIMG, LNS): For the sake of
	XHTML, quote more arguments.
	(IMG): Fix quoting.

2008-12-30  Werner LEMBERG  <wl@gnu.org>

	Fix quoting issues in www.tmac.

	* tmac/www.tmac (www:url_breaks_splitted): Renamed to...
	(www:url_breaks_split): This.
	(www->): New string to close tag singletons like <img> or <hr>.  In
	XHTML mode (not implemented yet), this has to be changed from `>' to
	`/>'.
	(IMG): Don't use </img>
	Use www->.
	(PIMG, MPIMG): Don't use </img>
	Use www->.
	Fix doublequote issues.
	(HR): Don't use </hr>.
	Use www->.
	(LNS): Fix doublequote issues.

2008-12-24  Michail Vidiassov  <master@iaas.msu.ru>

	* tmac/doc-common: Add entries for Mac OS X and FreeBSD.

2008-12-22  Alexey Gladkov  <legion@altlinux.ru>

	* contrib/groffer/perl/roff2.pl: Fix syntax error.

2008-12-15  Werner LEMBERG  <wl@gnu.org>

	* NEWS: Mention `preconv'.

2008-11-12  Werner LEMBERG  <wl@gnu.org>

	Implement `x' specifier for expanded columns.  Contrary to old DWB
	tbl, more than a single `x' specifier can be used.  At the same
	time, remove most of the code from change 2007-02-09 which collides
	with the new implementation.

	* src/preproc/tbl/main.cpp (format): Add `expand' array.
	(format::format, format::~format): Updated.
	(input_entry_format): Add `expand' field.
	(input_entry_format::input_entry_format): Updated.
	(input_entry_format::debug_print): Handle `expand'.
	(process_format): Handle `x' specifier.
	(process_data): Updated.

	* src/preproc/tbl/table.cpp (AVAILABLE_REG, COLCOUNT_REG): Remove.
	(EXPAND_REG): New macro.
	(table_entry::divert, block_entry::divert,
	alphabetic_block_entry::divert): Add parameter to control whether
	expanded columns shall be handled.
	(block_entry::do_width): Remove.
	(block_entry::do_divert): Add parameter to control whether expanded
	columns shall be handled.
	Treat expanded columns like columns with a minimum width.
	Remove `experimental' code.
	(table::table, table::~table, table::allocate): Updated.
	(table::set_expand_column): New function.
	(table::count_block_columns): Replace with...
	(table::count_expand_columns): This function.
	(table::divide_span): Handle expanded columns the same as equal
	columns.
	(table::sum_columns): Add parameter to control whether expanded
	columns shall be handled.
	(table::compute_available_block_width): Replace with...
	(table::compute_expand_width): This function.
	(table::compute_total_separation): New function, taking code from
	`compute_separation_factor'.
	(table::compute_separation_factor): Simpler code.  The check for the
	`EXPAND' flag has been moved to the caller.
	(table::compute_widths): Add `top-level' changes to handle expanded
	blocks.

	* src/preproc/tbl/table.h (table): New field `total_separation'.
	Remove `blockflag' array.
	Add `expand' array.
	Update member function declarations.

	* src/preproc/tbl/tbl.man: Document `x' specifier.
	Expand documentation to cover all aspects of Lesk's tbl reference.

	* NEWS: Document `x' specifier.

2008-11-08  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/tbl.man: Restructuring.
	Improve text block documentation.

2008-11-07  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/table.cpp (table::compute_widths): Use default
	scaling operator for minimum width.  Without this fix, `lw3' (or
	`lw(3)' would be handled as a column with a minimum width of 3u
	instead of 3n.

2008-11-05  Werner LEMBERG  <wl@gnu.org>

	* tmac/doc-common (Dt): Start a new page if necessary and set up
	headers.

	* tmac/andoc.tmac (reload-doc): Simplify due to change in
	doc-common.

	* NEWS: Document it.

2008-10-18  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/main.cpp (process_format): Rename `x' and `X' to
	`m' and `M', respectively.
	Sort entries in `switch' block.
	* src/preproc/tbl/tbl.man: Updated.
	Sort key entries; other minor improvements.

2008-10-17  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/table.cpp (table::compute_available_block_width):
	New function.
	(table::compute_widths): Replace some code with new function
	(shifted to a more appropriate place).
	* src/preproc/tbl/table.h: Updated.

2008-10-16  Werner LEMBERG  <wl@gnu.org>

	* tmac/doc-common (doc-operating-system-*), tmac/groff_mdoc.man: Add
	NetBSD 4.0.1.

2008-10-13  Werner LEMBERG  <wl@gnu.org>

	* tmac/groff_mdoc.man: Update documentation on BSD-like OS string
	versions.

2008-10-10  Werner LEMBERG  <wl@gnu.org>

	* man/roff.man, doc/groff.texinfo: Improve the history part.  This
	is based on input from Tom Van Vleck <thvv@multicians.org>.


	* src/preproc/eqn/sqrt.cpp (sqrt_box::compute_metrics): Assure that
	value of `rst' register is not zero, as can happen for the HTML
	output device.  Otherwise, there are too many loops, and we get a
	stack overflow because of recursion.

2008-10-05  Stephen Gildea  <http://www.gildea.com/stephen/>

	* src/preproc/ref/ref.cpp (reference::compute_sort_key): Do
	not insert SORT_SEP before the first field, so that sort_key
	has the same format as before the patch of 2003-08-23.

2008-10-04  Werner LEMBERG  <wl@gnu.org>

	* tmac/doc-common (doc-operating-system-*): Update releases.

	* tmac/an-old.tmac (an-extra1, an-extra2, an-extra3): Initialize.

	* tmac/andoc.tmac: Rewritten, based on a preliminary version from
	Tadziu Hoffmann.  It can now process multiple man pages with both
	man and mdoc formats intermixed.

	* NEWS, tmac/groff_man.man, tmac/groff_mdoc.man,
	man/groff_tmac.man: Document it.

2008-10-04  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cpp (do_suppress): Make \O[3], \O[4], and
	\O[5] non-transparent w.r.t. beginning-of-line recognition (similar
	to the other \O variants).

	* tmac/www.tmac (TS, TE, EQ, EN): Don't use .als for setting up
	default macros.  This causes endless loops (at least for TE).

	* doc/groff.texinfo: Improve documentation of `.als'.

2008-10-03  Werner LEMBERG  <wl@gnu.org>

	* src/devices/grops/grops.man, src/roff/troff/troff.man,
	src/preproc/soelim/soelim.man: Correct documentation of -I switch.
	Reported by Larry Kollar.
	Other minor formatting issues.

2008-10-02  Werner LEMBERG  <wl@gnu.org>

	* tmac/trace.tmac: Much improved.
	(trace-full): New register to be set on the command line; it
	controls whether number and string register assignments get traced
	also.
	(!!c): New macro for comments.
	(rm): New traced macro.
	(de, de1, am, am1): Use \\[xxx]\\ calling method to pass \$0 to
	`!!xxx'; this makes doc.tmac completely traceable.
	Trace call of .de and friends also.

	* tmac/groff_tmac.man, NEWS: Update.

2008-09-30  Werner LEMBERG  <wl@gnu.org>

	Restore behaviour of \$0 if a macro is called with string syntax
	(problem caused by change on 2008-09-29).

	* src/roff/troff/input.cpp (input_iterator, input_stack,
	macro_iterator): Add `get_macro_name' member function.
	(interpolate_string): Use it.

2008-09-29  Werner LEMBERG  <wl@gnu.org>

	Make \\*[xxx]\\ within a macro (with `xxx' a macro too) work as
	expected.  Without the patch,

	  .de aaa
	  \\*[bbb]\\
	  .  tm \\$*
	  ..
	  .de bbb
	  .  shift
	  ..
	  .aaa 1 2 3

	prints `2 3' instead of `1 2 3'.

	* src/roff/troff/input.cpp (input_iterator, input_stack,
	macro_iterator): Add `get_arg_list' member function.
	(macro): Add `is_a_string', `is_string', and `clear_string_flag'
	members.
	Update constructors and operators.
	(arg_list): Add copy constructor.
	(macro_iterator): Add optional argument to constructor to indicate
	whether arguments shall be inherited from calling macro.
	(interpolate_string): If string argument is a macro, push a macro
	iterator on the stack.
	(do_define_macro): Call clear_string_flag if macro data contains a
	newline.

	* src/roff/troff/request.h: Updated.

2008-09-29  Eric S. Raymond  <esr@snark.thyrsus.com>

	* doc/pic.ms: Fold in documentation of pic2plot(1) capabilities.
	Improve the documentation of text objects.

2008-09-28  Eric S. Raymond  <esr@snark.thyrsus.com>

	* contrib/pic2graph, contrib/pic2graph.man, contrib/eqn2graph,
	contrib/eqn2graph.man: Tweak scripts to cope with incompatible
	changes in ImageMagick crop options.  Document the bugs.

2008-09-28  Werner LEMBERG  <wl@gnu.org>

	If a macro is called as a string, inherit value of \n[.br] from the
	caller.  This is useful for `trace.tmac'.

	* src/roff/troff/input.cpp (string_iterator): New members
	`with_break' and `get_break_flag'.
	(string_iterator::string_iterator): Updated.

	* doc/groff.texinfo: Improve documentation of \$0 and string syntax
	calling of macros.
	Document behaviour of \n[.br] within strings.

2008-09-26  Werner LEMBERG  <wl@gnu.org>

	* tmac/trace.tmac: Add copyright message.
	Use `.de1' where possible to make source code more readable.
	(so, mso, als, rn): Restore escape character before executing the
	request.
	(de, de1, am, am1): Trace `.foo' also if called as `\\[foo]'.

2008-09-24  Werner LEMBERG  <wl@gnu.org>

	Fix incompatibility between `.de1' and `.do'.  Without this change,
	the following snippet

	  .de1 xx
	  .  tm \\n(.C
	  ..
	  .cp 1
	  .do xx

	prints 1 instead of 0.

	* src/roff/troff/input.cc (do_request): If a macro gets processed,
	call tok.next().
	(interpolate_macro): Add optional argument.  Update callers.
	(request::invoke): Add optional argument.
	(macro::invoke): Add optional argument to delay call of tok.next().

	* src/roff/troff/request.h (request_or_macro): Add argument to
	`invoke' member.  Update all derived classes.

	* doc/groff.texinfo: Improve documentation of .do request.

2008-09-09  Werner LEMBERG  <wl@gnu.org>

	* tmac/an-old.tmac (FT): Initialize properly.  Reported by Tadziu
	Hoffmann.

2008-09-06  Werner LEMBERG  <wl@gnu.org>

	* tmac/doc-common (Dd, Os, Dt): Reset `doc-command-name' to make
	`.Nm' work properly if next manual page is printed.

2008-08-20  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/tbl.man: Document computation of element widths.

2008-08-20  Alexey Gladkov  <legion@altlinux.ru>
	    Werner LEMBERG  <wl@gnu.org>

	Add default encoding option -D to preconv and groff.

	* src/preproc/preconv/preconv.cpp (default_encoding): Make it an
	array.
	Update all users.
	(main): Handle new option -D.
	(usage): Updated.
	* src/preproc/preconv/preconv.man: Updated.

	* src/roff/groff/groff.cpp (main): Handle new option -D.
	(synopsis, help): Updated.
	* src/roff/groff/groff.man: Updated.

2008-07-26  Werner LEMBERG  <wl@gnu.org>

	* tmac/eqnrc (.EQ, .EN): Provide default definitions.  Reported
	by Denis M. Wilson.

	* tmac/www.tmac (.EQ, .EN, .TS, .TE): Fix definitions.

2008-07-24  Denis M. Wilson  <dmw@oxytropis.plus.com>

	New options -f and -k for afmtodit.

	* src/afmtodit/afmtodit.pl: New options `-f NAME' sets the internal
	name of the groff font.
	New option `-k' disables output of kerning data.
	* src/afmtodit/afmtodit.man, NEWS: Document new options.

2008-07-18  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/table.cpp (table::compute_separation_factor): Emit
	warning messages if table gets squeezed.
	(table::compute_widths): Fix computation of AVAILABLE_REG.
	Emit warning if table is wider than line length.

	* src/preproc/tbl/tbl.man: Minor improvements.

2008-05-02  Larry Jones  <lawrence.jones@siemens.com>

	* contrib/chem/Makefile.sub (README, examples/README): In makefiles,
	the `$<' macro is only guaranteed to be defined in inference rules,
	not in explicit target rules.  Since there is only one input file in
	the places where it is used, the `$?' macro (which is guaranteed to be
	defined for both kinds of rules) is a suitable replacement.

	* hdtbl/examples/fonts_n.in, hdtbl/examples/fonts_n.in: Most
	versions of ls don't have a `--color' option.

2008-04-30  Larry Jones  <lawrence.jones@siemens.com>

	* Makefile.comm (depend.temp): Add `EXTRA_CCFLAGS'.

2008-04-29  Larry Jones  <lawrence.jones@siemens.com>

	* src/eqn/script.cpp (script_box::output): Portability fix.

2008-04-05  Dorai Sitaram  <ds26gte@yahoo.com>

	Add better support for `.TAG #<label>' in non-HTML documents: In
	case of a forward reference in a call to .URL, write `(see below)'.
	In case of a backwards reference use the page number instead.  The
	reference gets stored in a string `TAG_<label>' and can be
	overridden while calling `.TAG' with its new optional argument --
	this is useful for a second-pass system which resolves forward
	references.

	* tmac/www.tmac (www:url_check_tag): New function.
	(URL): Use it.
	(TAG): Add optional argument to define string `TAG_<label>'.

2008-03-24  Werner LEMBERG  <wl@gnu.org>

	* tmac/trace.tmac (so, mso): Added.

	* tmac/www.tmac (PIMG): Replace `.ie' (without `.el') with `.if'.
	If used with -mtrace, and this clause was active, the macro was
	executed twice.

	* tmac/pspic.tmac (PSPIC): Accept option `-C' for orthogonality.
	This makes `.PIMG -C <file>' (from www.tmac) work on non-HTML
	devices.
	* man/groff_tmac.man: Document it.

2008-02-26  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cpp: s/safer_flag/unsafe_flag/.
	Update all occurrences so that \n[.U] works as advertised.  Bug
	reported by Dorai Sitaram.

2008-02-17  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Improve documentation of .cf request.

2008-01-19  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/html/pre-html.cpp (usage): Don't describe options but
	mention that it should never be called stand-alone.

	* tmac/groff_www.man, doc/groff.texinfo, man/groff_font.man,
	man/groff_tmac.man, man/groff_out.man, README, README.MinGW,
	src/roff/groff/groff.man: Mention -Txhtml.

	* man/groff_font.man, man/groff_tmac.man, man/roff.man: Revised.

2008-01-16  Werner LEMBERG  <wl@gnu.org>

	* src/libs/libgroff/font.cpp (font::contains, font::get_code):
	Handle single-letter names correctly.

	* doc/groff.texinfo, man/groff_diff.man: Extend documentation of \^
	and \|.
	* NEWS: Updated.

2008-01-15  Werner LEMBERG  <wl@gnu.org>

	* man/groff_font.man: Revised.

2008-01-14  Werner LEMBERG  <wl@gnu.org>

	* man/groff.man: Mention glyph and characters.
	Minor other updates.
	* man/groff_char.man: Minor updates.
	* man/groff_diff.man: Better clarification between characters and
	glyphs.

2008-01-12  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Fix top-level structure to make it compilable
	again with all texinfo modes.  Reported by Jörg van den Hoff
	<j.van_den_hoff@fzd.de>.

2008-01-11  Werner LEMBERG  <wl@gnu.org>

	* doc/pic.ms: Mention that compass points of line objects are
	arbitrarily located.

2008-01-06  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/node.cpp (left_italic_corrected_node::add_self):
	Don't remove itself if there is no glyph associated with the node
	yet.  This happens, for example, in this situation:

	  .ll 15000u
	  .ft I
	  x x
	  (\,f

2008-01-05  Werner LEMBERG  <wl@gnu.org>

	* man/groff_char.man, man/groff.man: Revised.

	* src/preproc/eqn/lex.cpp (troff_defs): Fix typo.

2008-01-04  Werner LEMBERG  <wl@gnu.org>
	* */*: s/Osanna/Ossanna/.

	* */*.man: Replace .URL with .UR/.UE (except in groff_www.tmac).
	Replace .MTO with .MT/.ME (except in groff_www.tmac).
	Insert `\:' in URLs where appropriate.
	Don't include www.tmac (except in groff_www.tmac).

	* man/groff.man (.ESC[]): Fix font of closing bracket.
	(.ESCq): Fix font of closing quote character.
	Many other improvements.

2007-12-30  Bernhard Fisseni  <bfi@ikp.uni-bonn.de>

	* src/devices/grohtml/post-html.cc
	(html_printer::writeHeadMetaStyle): Fix CSS output.

2007-12-29  Werner LEMBERG  <wl@gnu.org>

	* tmac/ec.tmac: Add CM fonts to the .fspecial lines; those fonts
	contain additional glyphs (like some uppercase Greek letters).

2007-12-06  Werner LEMBERG  <wl@gnu.org>

	* NEWS: Updated.

2007-12-06  Colin Watson  <cjwatson@debian.org>

	* src/roff/nroff/nroff.sh: Add options -w and -W.
	* src/roff/nroff/nroff.man: Document them.

2007-12-06  Karl Berry  <karl@freefriends.org>

	* tmac/hyphenex.pl: Update header output.

2007-11-29  Werner LEMBERG  <wl@gnu.org>

	* src/devices/grotty/tty.cpp (tty_printer::line): Fix line lengths.

2007-11-20  Werner LEMBERG  <wl@gnu.org>

	* doc/pic.ms: Add Heinz-Jürgen's 3d boxes example.

2007-11-17  Werner LEMBERG  <wl@gnu.org>

	* src/roff/nroff/nroff.sh: Handle GROFF_TYPESETTER environment
	variable.  Problem reported by Michael G Schwern
	<schwern@pobox.com>.

	* src/roff/nroff/nroff.man: Document it.
	Other minor updates.

2007-11-17  Heinz-Jürgen Oertel <hj.oertel@t-online.de>

	* src/groff/preproc/pic/lex.cpp (table): Add box attributes
	`xslanted' and `yslanted'.

	* src/groff/preproc/pic/object.cpp (object_spec::object_spec):
	Initialize `xslanted' and `yslanted'.
	(graphic_object): Add methods `set_xlanted' and `set_yslanted'.
	(closed_object): Ditto.
	Add members `xslanted' and `yslanted'.
	(box_object::print): Use them.
	(object_spec::make_object): Handle slant values.
 	* src/groff/preproc/pic/object.h (IS_XSLANTED, IS_YSLANTED): New
	constants.
	(object_spec): Add members `xslanted' and `yslanted'.
	* src/groff/preproc/pic/pic.y (XSLANTED, YSLANTED): New left-valued
	tokens.
	Add rules for them.
	
	* src/groff/preproc/pic/pic.man, NEWS, doc/pic.ms: Document above
	changes.

2007-11-16  Werner LEMBERG  <wl@gnu.org>

	* tmac/hyphenex.pl: Generate copyright notice (this has been
	approved by Barbara Beeton).
	* tmac/hyphenex.us: Updated.

2007-11-10  Michail Vidiassov  <master@iaas.msu.ru>

	* tmac/doc-syms (doc-str-St--susv3): New string.
	* tmac/groff_mdoc.man: Document it.

2007-11-08  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/preconv/preconv.cpp (emacs_to_mime): Add `utf-16be',
	`utf-16le', `utf-16be-with-signature', `utf-16le-with-signature'.
	(is_comment_line): Handle '\" and '\# also.

	* src/preproc/preconv/preconv.man: Revise and make complete.

2007-10-25  Werner LEMBERG  <wl@gnu.org>

	* tmac/cs.tmac: New file holding Czech strings, contributed by
	Marcela Maslanova <mmaslano@redhat.com>.
	* tmac/hyphen.cs, tmac/hyphenex.cs: New hyphenation pattern files
	for Czech, taken from CTAN.
	* LICENSES: Updated.
	* tmac/Makefile (NORMALFILES): Add Czech stuff.
	* doc/groff_tmac.man: Mention cs.tmac.

2007-10-21  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cpp (do_ps_file): Handle `%X' in header
	comments correctly.  Reported by Frank Jahnke
	<jahnke@sonatabio.com>.

2007-10-02  Ruslan Ermilov  <ru@FreeBSD.org>

	* tmac/doc-common, tmac/groff_doc.man: Add FreeBSD 6.2, document
	FreeBSD 5.5 and 7.0.

	* tmac/doc-syms: Give better names for System V releases.

2007-09-25  Gaius Mulley  <gaius@glam.ac.uk>

	* doc/Makefile.in, doc/Makefile.sub (.ms.html): Add -P-V switch to
	the production of html files.
	(pic.html): Ditto.
	Remove background colour switch.
	(.SUFFIXES, clean): Handle *.xhtml files.

	* src/devices/grohtml/grohtml.man: Document that -V option now
	generates an HTML-4.01 validator or XHTML validator.

	* src/devices/grohtml/html-text.cpp (html_text::end_tag,
	html_text::start_tag): Suppress <small>, <big>, and <color> tags if
	we are inside a <pre> block.

	* src/devices/grohtml/post-html.cpp
	(html_printer::handle_valid_flag): Add a parameter to indicate
	whether it needs to generate a paragraph block.
	(html_printer::write_navigation): Updated.
	(html_printer::do_file_components): Generate an HTML-4.01 blue
	validator button also.

2007-09-23  Axel Kielhorn  <A.Kielhorn@web.de>

	* man/groff.man: Fix URL of CSTR 54.

2007-09-23  Werner LEMBERG  <wl@gnu.org>

	* man/groff_char.man: Normalize character set names as defined
	by IANA.  Based on a patch from Axel Kielhorn.

	* src/preproc/refer/label.y: Undo change from 2007-09-19.

2007-09-19  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cpp (interpolate_arg): Remove compiler
	warning.

	* src/preproc/eqn/pile.cpp (pile_box::output, matrix_box::output):
	Remove compiler warning.

	* src/preproc/refer/label.y: Remove compiler warning.

	* src/preproc/pic/pic.y: Remove doubled token entries.

2007-09-19  Gaius Mulley  <gaius@glam.ac.uk>

	* doc/groff.texinfo: Document new .O register and add cross
	reference entries.

	* NEWS: Updated.

	* src/devices/grohtml/grohtml.man: Document new -V and -y options.

	* src/devices/grohtml/html-table.cpp: Add support for XHTML 1.1.
	(html_table:: emit_colspan, html_table::emit_td): New methods.
	(html_table::emit_col): Use html_table::emit_td.
	(html_table::emit_table_header): Use html_table::emit_colspan if
	dialect xhtml is specified.
	(html_table::finish_row): Updated.

	* src/devices/grohtml/html-table.h (html_table): Declare
	emit_colspan, emit_td.

	* src/devices/grohtml/html-text.cpp: Modified tags to comply with
	xhtml if this dialect was requested.

	* src/devices/grohtml/html-text.h (html_dialect): New enumeration.
	(html_text): Add new variable `dialect'.

	* src/devices/grohtml/post-html.cpp: Modify header tags to be XHTML
	compliant.
	(valid_flag, groff_sig, dialect): New global variables.
	(html_printer::handle_valid_flag, html_printer::do_math,
	html_printer::write_html_anchor, html_printer::write_xhtml_anchor,
	html_printer::do_math, html_printer::handle_valid_flag): New
	methods.
	(html_printer::emit_line, html_printer::emit_raw,
	html_printer::do_check_center, html_printer::write_title,
	write_rule, html_printer::writeHeadMetaStyle, generate_img_src,
	html_printer::begin_page): Altered to be XHTML compliant.
	(html_printer::write_header): Updated.
	(html_printer::troff_tag): Call do_math.
	(html_printer::insert_split_file, html_printer::do_file_components,
	html_printer::write_navigation): Create XHTML file components if
	necessary and also produces a groff signature if requested.
	(~html_printer): Call writeHeadMetaStyle at appropriate places
	depending upon html_dialect.
	(html_printer::special): Handle new tags `html<?p>' and `math<?p>'.
	(main): Added options -x, -V, and -y.
	(usage): Updated.

	* src/preproc/eqn/box.cpp: Create a distinction between
	the MathML device and the XHTML device.
	(do_text): Issue a newline at the end of the equation if XHTML was
	specified.
	(box::top_level): Prefix the output of an equation by the .MATHML
	macro.
	(output_string): Suppress \n if XHTML was specified.

	* src/preproc/eqn/main.cpp (xhtml): New global flag.
	(inline_equation): Skip leading spaces after inline equation for
	XHTML device.
	(main): Set `xhtml' flag if `-Tmathml:xhtml' is specified.

	* src/preproc/eqn/eqn.h (xhtml): New external flag.

	* src/preproc/eqn/text.cpp (entity_table): Fix typo.

	* src/preproc/html/pre-html.cpp (html_dialect): New enumeration.
	(dialect, eqn_flag): New global variables.
	(html_system): Improve debugging support.
	(alterDeviceTo): Test for -Txhtml when altering device to the image
	device and reset to -Txhtml.
	(addZ): Renamed to...
	(addArg): This.
	Introducea a general parameter.
	(print_args): New debugging function.
	(char_buffer::run_output_filter): Use print_args and addArg rather
	than addZ.
	(char_buffer::do_html, char_buffer::do_image): Add -rxhtml=1 command
	line parameter as an argument to the html generation of text when
	xhtml is needed.  Include -e on the command line if mathml is
	required.
	(scanArguments): Allow -e, -V, -y and -x options.
	-V, -y are handled by the back end.  -e sets `eqn_flag'.
	-x determines HTML dialect.

	* src/roff/groff/groff.cpp (possible_command): New method
	`clear_name'.
	(main): Set eflag if -e is present on command line.
	Set is_xhtml if -Txhtml is present.
	Pass `-x x' to the HTML pre and post processors.
	Pass `-e' to the HTML pre processor if required.
	Pass `-Tmathml:xhtml' to eqn if XHTML is requested.

	* src/roff/troff/input.cpp (init_input_requests): Introduce new
	number register `\n[.O]'.

	* tmac/s.tmac: (LP): Use .nop for semantic sugar.
	(cov*ab-init) reformat.
	(@EQ): Use EQN-HTML-IMAGE and friends rather than HTML-IMAGE.
	(CHECK-FOOTER-AND-KEEP): Define FS, FE such that they use
	<cite></cite> for the html device rather than generate images for
	footnotes.

	* tmac/troffrc-end: Define EQN-HTML-IMAGE,
	EQN-HTML-IMAGE-END, EQN-HTML-IMAGE-RIGHT,
	EQN-HTML-IMAGE-LEFT, EQN-HTML-IMAGE-INLINE,
	EQN-HTML-DO-IMAGE, EQN-HTML-IMAGE-END as null strings.

	* tmac/www.tmac: (HTML<?p>): New macro.
	(MATH<?p>): New macro.
	(IMG, PIMG, MPIMG, HR): Use XHTML compliant syntax.
	(www-emit-ltag): New macro.
	(www-push-li): Updated.
	(ULS): Ensure that tags are balanced in order by use of
	www-emit-ltag.
	(ULE): Likewise: Use www-emit-ltag and shut down paragraphs in
	order.
	(OLS, OLE, DLS, DLE): Ditto.
	<global>: Define EQ and EN to EQN-HTML-IMAGE and EQN-HTML-IMAGE-END
	respectively.
	(www-li-ul, www-li-ol, www-li-dl): Updated.
	(EQN-HTML-IMAGE, EQN-HTML-IMAGE-RIGHT, EQN-HTML-IMAGE-LEFT,
	EQN-HTML-IMAGE-INLINE, EQN-HTML-DO-IMAGE, EQN-HTML-IMAGE-END,
	MATHML): New macros.

2007-09-17  Werner LEMBERG  <wl@gnu.org>

	* man/groff_font.man: Document `unicode' keyword.
	* doc/groff.texinfo (DESC File Format): Synchronize with
	groff_font.man.

2007-09-15  Werner LEMBERG  <wl@nu.org>

	* man/groff.man: Document `\_'.
	* doc/groff.texinfo: Ditto.
	Remove references to `\@' which isn't a valid escape sequence in
	groff.


	* tmac/unicode.tmac: Add ` and '.
	* tmac/html.tmac: Load unicode.tmac.

2007-09-14  Werner LEMBERG  <wl@gnu.org>

	* tmac/unicode.tmac: Make `-' a pure input character by mapping it
	to `hy'.

	* src/roff/troff/input.cpp (init_charset_table): Handle `hy'.

2007-09-11  Werner LEMBERG  <wl@gnu.org>

	* src/libs/libgroff/string.cpp (string::remove_spaces): Fix memory
	allocation.

	* src/preproc/tbl/table.cpp (table::allocate): Initialize
	`blockflag' array.

2007-09-10  Keith Marshall  <keith.d.marshall@ntlworld.com>

	* README.MinGW: Add warnings about use of MSYS-RXVT, and about
	defective GnuWin32 versions of netpbm/libpng.

2007-07-15  Keith Marshall  <keith.d.marshall@ntlworld.com>

	* tmac/s.tmac (cov*first-page-init): Remove invoking trap, to avoid
	possible recursion.

2007-07-11  Werner LEMBERG  <wl@gnu.org>

	* gendef.sh: Add shebang.

2007-07-05  Werner LEMBERG  <wl@gnu.org>

	* tmac/papersize.tmac: Fix dimensions of executive paper format.
	Reported by John Rupley <rupley@u.arizona.edu>.

2007-07-02  Keith Marshall  <keith.d.marshall@ntlworld.com>

	* tmac/s.tmac (cov*first-page-init): Emit error message if not in
	top-level environment.

2007-06-12  Werner LEMBERG  <wl@gnu.org>

	* src/devices/xditview/TODO, NEWS: Updated.
	* src/devices/xditview/Makefile.sub (install_data, uninstall_sub):
	Handle `GXditview-color'.
	* src/devices/xditview/gxditview.man: Updated.

	* m4/groff.m4 (GROFF_APPRESDIR_CHECK): Updated.
	* m4/codeset.m4, m4/glibc21.m4, m4/iconv.m4, m4/lib-link.m4: Updated
	from `gnulib' git repository.

	* configure.ac: Updated.
	* configure: Regenerated (using autoconf 2.61).

	* config.guess, config.sub: Updated from `config' CVS repository.
	* config.rpath, install-sh, mkinstalldirs: Updated from `gnulib' git
	repository.

2007-06-12  Tadziu Hoffmann  <hoffmann@usm.uni-muenchen.de>

	* src/devices/xditview/GXditview.ad: Split off color definitions
	into...
	* src/devices/xditview/GXditview-color.ad: This new file.

2007-06-08  Fabrice Ménard  <menard.fabrice@wanadoo.fr>

	* tmac/fr.tmac: Handle chapter system for `me'.

2007-06-05  Tadziu Hoffmann  <hoffmann@usm.uni-muenchen.de>

	* src/devices/xditview/xditview.c (main): Add support for
	accelerators.

	* src/devices/xditview/GXditview.ad: Updated.
	Make widget more colourful.

2007-05-30  Werner LEMBERG <wl@gnu.org>

	* tmac/groff_mdoc.man: Convert `-' to `\-' where appropriate.
	Recommend `tbl' instead of `-column' lists for more complicated
	cases.

2007-05-21  Werner LEMBERG  <wl@gnu.org>

	* src/devices/grops/ps.cpp (ps_printer::set_char): Handle subfonts
	correctly.

2007-04-10  Werner LEMBERG  <wl@gnu.org>

	In pic, make rounded boxes work with colors.  Reported by Urs Eggli
	<Urs.Eggli@zuerich.ch>.

	* src/preproc/pic/common.h (common_output), src/preproc/pix/output.h
	(output): Add color parameter to `rounded_box' member function.

	* src/preproc/pic/common.cpp (common_output::rounded_box): Use it.

	* src/preproc/pic/object.cpp (box_object::print): Pass `color_fill'
	to `out->rounded_box'.

2007-04-09  Michail Vidiassov  <master@iaas.msu.ru>

	* font/devps/generate/textmap: Add Greek letters and some more.

	* src/utils/afmtodit/afmtodit.tables: Change values of `Delta',
	`Omega', and `mu' to the ones from aglfn.txt.

2007-04-08  Keith Marshall  <keith.d.marshall@ntlworld.com>

	* tmac/s.tmac (SN): Define unconditionally.
	(SN-STYLE): New string; define.

	* NEWS, tmac/groff_ms.man, doc/groff.texinfo (SN-STYLE): Document it.

2007-03-22  Werner LEMBERG  <wl@gnu.org>

	* tmac/pspic.tmac: Fix harmless numeric overflow warning.  Reported
	by Jörg van den Hoff <j.van_den_hoff@fzd.de>.

2007-03-20  Werner LEMBERG  <wl@gnu.org>

	* tmac/trace.tmac (rn): Added.
	(nr, ds, ds1, as, as1, substring): Restore escape character while
	executing the macro.
	(nr): Remove dead code.

	* src/preproc/eqn/box.cpp (box::top_level): Use \E in string
	definitions to make them traceable.

2007-03-19  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cpp (get_copy): Add third argument to control
	whether \E shall be expanded.
	(get_char_for_escape_name): Allow \E.

2007-03-15  Werner LEMBERG  <wl@gnu.org>

	* tmac/s.tmac (MO, CH, pg*OH, pg*EH, pg*OF, pg*EF, *, [., .],
	par*define-font-macro, \[hooko]): Use \E to make it traceable.

	(ref*field): Add argument to control the space between previous and
	current argument.
	Update all callers.
	(ref*add-N): Fix handling of opening parenthesis.  Problem reported
	by Jörg van den Hoff <j.van_den_hoff@fzd.de>.

2007-03-14  Werner LEMBERG  <wl@gnu.org>

	* tmac/trace.tmac (als): Added.
	(de, de1, am, am1): Make traced macros aliased with .als work.

2007-02-25  Werner LEMBERG  <wl@gnu.org>

	* src/devices/xditview/TODO: Add some more items.

	* Makefile.comm (.man.n): Add @APPRESDIR@.
	Sort entries.

	* src/devices/xditview/gxditview.man: Document GXditview resource
	file.
	Other documentation enhancements based on a patch from Jörg.

2007-02-25  Tadziu Hoffmann  <hoffmann@usm.uni-muenchen.de>
	    Joerg van den Hoff <j.van_den_hoff@fzd.de>

	* src/devices/xditview/GXditview.ad: Make all keys work regardless
	of the current mouse position.

2007-02-20  Werner LEMBERG  <wl@gnu.org>

	* tmac/groff_man.man: Revised to improve visual appearance.
	Reduce use of future tense.

	* tmac/groff_trace.man: Revosed to improve visual appearance.

2007-02-19  Eric S. Raymond  <esr@snark.thyrsus.com>

	Make groff.man viewer-portable.

	* tmac/groff.man: Eliminate use of .eo/.ec.
	(.REQ): Surround args 2 through N with quotes.  This will enable us
	not to rely on the shift request, which is nonportable.
	(ExecFF): Remove.  The code is simpler without it.

2007-02-18  Eric S. Raymond  <esr@snark.thyrsus.com>

	* tmac/groff_www.man: Viewer-portability fixes.

2007-02-16  Eric S. Raymond  <esr@snark.thyrsus.com>

	* man/groff.man: Remove some unneeded code and a no-longer-used
	inclusion of the www macros.

2007-02-12  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/table.cpp (compute_span_width): Fix use of
	AVAILABLE_REG.
	(table::compute_widths): Simplify.

2007-02-11  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/table.h: Don't include `stdbool.h'.
	(table): Replace `bool' type with `char' for orthogonality.
	Update all users.

	* src/preproc/tbl/table.cpp (block_entry::do_divert): Fix usage of
	AVAILABLE_REG and COLCOUNT_REG.
	(table::table): Fix order call of initializers.
	(table::~table): Deallocate `blockflag'.

2007-02-09  Eric S. Raymond  <esr@snark.thyrsus.com>

	A try at the new rule for block column allocation is now enabled by
	the new `experimental' global option: The horizontal space up to the
	right margin which is not used by columns without text blocks is
	evenly distributed to the columns with text blocks.

	It doesn't work right as yet; there appears to be some error in the
	computation of `3avail', the available line length.  The purpose of
	this patch is (a) to make experimenting with other formulas easy,
	and (b) leave the infrastructure for flag `experimental' in place
	for future experiments.  Do not document any behavior associated
	with this flag!

	* src/preproc/tbl/table.h: Include `stdbool.h'.
	(table): Make `flags' public.
	Add `count_block_columns' function.
	Add `blockflag' array.
	Add `EXPERIMENTAL' enumeration value.

	* src/preproc/tbl/table.cpp (AVAILABLE_REG, COLCOUNT_REG): New
	macros.
	(table_entry): New member `parent' so that class and subclass
	members can set a parent field.  Update all users.
	(block_entry::do_divert): Handle `EXPERIMENTAL' flag.
	(block_entry::do_width): Set the parent's `blockflag'.
	(table::allocate): Handle `blockflag'.
	(table::count_block_columns): New function.
	(compute_span_width): Adjust AVAILABLE_REG.
	(table::compute_widths): Handle COLCOUNT_REG and AVAILABLE_REG.

	* src/preproc/tbl/main.cpp (process_options): Handle `experimental'
	option.

2007-02-08  Zhao, Yu (William)  <yzhao2@alcatel-lucent.com>

	* src/devices/grodvi/dvi.cpp (draw_dvi_printer::draw) <'e'>: Set
	line thickness.

2007-02-08  Werner LEMBERG  <wl@gnu.org>

	* man/groff_out.man (offset): Make it work reliably.

2007-02-07  Eric S. Raymond  <esr@snark.thyrsus.com>

	* man/groff_out.man: Simplify some font changes so \fP is less
	likely to do something surprising.
	
	* man/groff_out.man: We can simplify the command macros still
	further if we stop trying to hide structural requests inside them.
	Also, fix some instances of \} at start of line without a dot, and
	make some font changes explicit in strings.
	
	* man/groff_out.man: Cleanup -- remove now-unneeded uses of .do and
	.cp.
	
	* man/groff_out.man: Final step: Reduce x-command, get rid of eo/ec
	calls and fix macros to do without them.  File should now be
	viewer-portable.
	
	* man/groff_out.man: Fourth step: Eliminate use of eqn in favor of
	micromotions that produce the same visual result and can be lifted
	to XML-DocBook.
	
	* man/groff_out.man: Third step: Reduce Da-comand, fix a
	call-sequence bug in the original.
	
	* man/groff_out.man: Second step: Reduce D-commmand and D-command+,
	move font-change escapes to portable form.

	* man/groff_out.man: First step in macro simplification; eliminate
	list1..n, simplify .offset and .index_offset so they no longer
	require groff-specific features or eqn (instead, use troff
	micromotions for subscripting).

2007-02-06  Eric S. Raymond  <esr@snark.thyrsus.com>

	* src/preproc/eqn/eqn.man: Minor corrections.

	* tmac/an-ext.tmac: Change .UR/.UE and .MT/.ME so the start macro no
	longer takes a second argument that is pasted to the end of the
	generated text.  Instead, the end macro takes an argument that does
	the same thing.

	* man/ditroff.man, man/groff_diff.man, man/groff.man,
	man/groff_out.man, man/groff_tmac.man, man/roff.man,
	src/roff/groff/groff.man, src/roff/grog/grog.man,
	tmac/groff_man.man, tmac/groff_trace.man: Update accordingly.

	* src/roff/troff/troff.man: .SY and .YS are canned macros now,
	so we can use them here.
	
2007-02-05  Eric S. Raymond  <esr@snark.thyrsus.com>

	* src/preproc/eqn/lex.cpp, src/preproc/eqn/eqn.man:
	By popular demand, make ... set three lower dots again
	and introduce a new predefined macro 'cdots' to set
	three centered dots.

2007-02-05  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/eqn/eqn.man: Revised.

	* src/preproc/eqn/text.cpp (map, special_char_boc::output): Use
	`const'.
	(spacing_type): Fix typo.
	(special_to_entity): Use `const'.
	Remove unused variable.
	* src/preproc/eqn/other.cpp (font_box::output): Use `const'.

2007-02-05  Eric S. Raymond  <esr@snark.thyrsus.com>

	* src/devices/grotty/grotty.man: \m[] and \M[] aren't portable,
	which is a shame as the effect was cute.

2007-02-04  Eric S. Raymond  <esr@snark.thyrsus.com>

	* man/groff_tmac.man, man/groff_diff.man: Portability conversion;
	rip out over-elaborate macrology, use .EX/.EE and .UR/.UE where
	possible, remove preamble declarations and macros that are no
	longer needed.  Conversion checked using the protocol described in
	tmac/TESTING-HINTS.

2007-02-03  Werner LEMBERG  <wl@gnu.org>

	* tmac/an-old.tmac (LP, IP, HP): Use .ns to suppress additional
	vertical space.

2007-02-03  Eric S. Raymond  <esr@snark.thyrsus.com>

	* tmac/groff_man.man: Documented the extension macros, and
	added portability advice.

	* MORE.STUFF: More-stuff entries for doclifter and pic2plot.


	Add support for MathML output to eqn.

	The strategy used is very simple and relies on the fact that the box
	models of eqn and Presentation MathML differ in only trivial ways.
	It leaves the grammar and existing internal object structures
	unchanged.  A new global, `output_format', is defined as an
	enumerated type with values {troff, mathml}.  Most of the functions
	and methods that emit actual output acquire a top-level conditional,
	dispatching on this global, which has one arm for troff mode and one
	for MathML mode.  In most cases the MathML arm is drastically
	simpler.

	(This strategy could be easily generalized to support other output
	formats.  TeX is a possibility that leaps to mind.)

	The only even moderately tricky changes are in the lexer.  Some of
	the predefined macros used constructs like `up', `down', `fwd',
	`back', and `vcenter' that have no equivalents in MathML.  I
	attacked this problem in these ways:

	1. I eliminated three uses of `back' to compose characters in favor
	   of using equivalent groff specials `\(<<', `\(>>', and `\(<>'
	   that did not exist when these macros were written.  (This will be
	   a quality improvement for troff users.)

	2. I eliminated one use of `vcenter' by using \\(md.  (Likewise...)

	3. I then split the table of pre-definitions in three; one large
	   common table and two small troff-specific and MathML-specific
	   tables.  Use of troff-only operations (up, down, back, fwd,
	   vcenter) is now confined to the former.  The latter now uses
	   `size big' and drops out the explicit positioning operations,
	   counting on MathML processors to do them.

	POTENTIAL TROUBLE SPOTS:

	Here are notes for reviewers on places I'm not 100% sure I've done
	the right thing:

	* In the process of preparing the troff table, I translated three
	  definitions (dot_def, dotdot_def, and utilde def) that previously
	  used explicit \v escapes to use `up' and `down' instead.  I
	  modeled the new definitions on the way `vec' and `dyad' work, but
	  it's possible I got something subtle wrong.

	* I'm not certain the MathML implementation of font_box::output() is
	  right, because I don't quite get what the switcheroo between
	  `current_roman_font' and `old_roman_font' is supposed to
	  accomplish.  It does seem to generare good MathML, though.

	Finally, I made one purely cosmetic change in `text.cpp'; I replaced
	with an enum some magic numbers for spacing types that I thought
	were too ugly to live.

	REMAINING ISSUES:

	The entirety of eqn is translated when `-TMathML' is specified,
	with the following exceptions...

	Limitations that cannot be fixed include non-support for special,
	up/down/fwd/back, and vcenter.

	Limitations that might be fixable include non-support for mark and
	lineup.  I will investigate further, but if these can be implemented
	at all it's going to be in a very complicated and nasty way.

	The way character boxes are output means that each digit of a
	multi-digit number gets its own <mn></mn> tag pair in the MathHTML.
	While this is not technically wrong for Presentation MathML, it is
	ugly and inefficient.  Fixing this will require implementing a
	little state machine in the `text.cpp' output method.

	* src/preproc/eqn/box.cpp, src/preproc/eqn/delim.cpp,
	src/preproc/eqn/eqn.h, src/preproc/eqn/eqn.man,
	src/preproc/eqn/lex.cpp, src/preproc/eqn/limit.cpp,
	src/preproc/eqn/list.cpp, src/preproc/eqn/main.cpp,
	src/preproc/eqn/other.cpp, src/preproc/eqn/over.cpp,
	src/preproc/eqn/pile.cpp, src/preproc/eqn/script.cpp,
	src/preproc/eqn/sqrt.cpp, src/preproc/eqn/text.cpp,
	src/preproc/eqn/eqn.man: MathML output mode.

	* NEWS: Document it.

2007-02-02  Eric S. Raymond  <esr@snark.thyrsus.com>

	* src/roff/groff/groff.man: Converted to use .SY/.OP/.YS
	and for cross-viewer portability.  Conversion checked
	using the protocol described in tmac/TESTING-HINTS.

2007-02-02  Werner LEMBERG  <wl@gnu.org>

	* tmac/an-ext.tmac (ME): Don't use `\:'.

	* src/roff/grog/grog.man: Further refinements and normalizations.

2007-02-02  Eric S. Raymond  <esr@snark.thyrsus.com>

	* src/roff/grog/grog.man: Converted to use .SY/.OP/.YS and for
	cross-viewer portability.  Conversion checked using the protocol
	described in tmac/TESTING-HINTS.

2007-02-01  Eric S. Raymond  <esr@thyrsus.com>

	* tmac/TESTING-HINTS: Added.

2007-02-01  Eric S. Raymond  <esr@thyrsus.com>

	Enable the support for Bell archaisms on .SC, so the `-r bell'
	switch is no longer needed to format old AT&T papers like
	the EQN user guide.

	* tmac/s.tmac (.SC, .UC, .P1, .P2): Updated.

	* tmac/groff_ms.man, doc/groff.texinfo, NEWS: Updated.

2007-02-01  Eric S. Raymond  <esr@thyrsus.com>

	Add some Bell labs extensions to the -ms macros.

	* tmac/s.tmac (.SC, .UC, .P1, .P2) [bell]: New macros.

	* tmac/groff_ms.man, doc/groff.texinfo, NEWS: Document `-r bell'.

2007-01-30  Werner LEMBERG  <wl@gnu.org>

	* tmac/an-ext.tmac (\n[EX]): Rename to \n[mX].
	(\n[mH]): New register (set if grohtml is used).
	(\n[SY]): Rename to \n[mS].
	(\n[a]): Rename to \n[mA].
	(\n[i]): Rename to \n[mI].
	(mU): New auxiliary input trap macro.
	(UR, UE): Replace stub with real definition.
	(URL): Remove.
	(MT, ME): New macros.
	(MTO): Remove.
	(EX, EE): Don't insert vertical space.
	Use a register to store (and restore) the current font.

	* man/ditroff.man, man/groff_diff.man, man/roff.man: Revised, based
	on patches from Eric Raymond.
	Fix URL addresses.

2007-01-22  Gaius Mulley  <gaius@glam.ac.uk>

	* tmac/an-old.tmac (an-trap, HP): Make `HP' work as expected.

2007-01-22  Werner LEMBERG  <wl@gnu.org>

	* tmac/an-ext.tmac: Protect against being sourced twice.
	(URL, EE): Use always two backslashes.
	(MTO): New macro.

2007-01-16  Werner LEMBERG  <wl@gnu.org>

	* tmac/an-ext.tmac: Remove code for grodvi.
	(SY): Fix typos.
	Don't insert empty line.
	(URL, TQ): Fix typos.

2007-01-14  Werner LEMBERG  <wl@gnu.org>

	* tmac/an-ext.tmac: New file, containing extension macros
	for -man.  See discussion on the groff mailing list for
	background information.
	* tmac/an-old.tmac: Load an-ext.tmac.
	Decorate .ds and as with comment escapes where appropriate.
	* tmac/Makefile.sub (NORMALFILES): Add an-ext.tmac.

2007-01-05  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/tbl.man: Document .T# and \n[TW].

2007-01-04  Gaius Mulley  <gaius@glam.ac.uk>

	Make -me macros ready for grohtml.

	* tmac/e.tmac: Load devtag.tmac.
	(need_eo_h, need_eo_tl, need_tl): New registers.
	(check_need_title, (x-html, )x-html, xp-html): New macros.
	(@h, hl, ip, @p, sh, (b, (l, EQ, EN, TS, TE, PS, PE, GS, GE, r, i,
	b, rb, bi, bx, (x, )x, xp): Adapt for use with grohtml.
	(bp): Rename to @b only if output device is not html.

2007-01-01  Werner LEMBERG  <wl@gnu.org>

	* man/groff_font.man: Document empty lines.

	* src/utils/afmtodit/afmtodit.pl: Always print a header comment at
	the very beginning of the output.
	[!$opt_x]: Fix typo.

	* font/devps/*: Regenerate font definition files.

2007-01-01  Werner LEMBERG  <wl@gnu.org>

	* font/devps/generate/Makefile (AFMTODIT): Use -c flag.

	* font/devps/*: Regenerate font definition files.

2006-12-31  Werner LEMBERG  <wl@gnu.org>

	* Makefile.in (oldfontdir): New variable.
	(MDEFINES): Add $(oldfontdir).
	(uninstall_dirs): Remove `current' link.
	Remove $(oldfontdir).

	* Makefile.comm (oldfontsubdir): New variable.
	(install_dev): Install files collected in $(OLDDEVFILES) into
	$(oldfontsubdir).
	(uninstall_dev): Remove data in $(oldfontsubdir).
	(.man.n): Handle @OLDFONTDIR@.

	* src/devices/grodvi/grodvi.man, src/devices/grohtml/grohtml.man,
	src/devices/grolbp/grolbp.man, src/devices/grolj4/grolj4.man,
	src/devices/grotty/grotty.man, src/devices/xditview/gxditview.man:
	Document GROFF_FONT_PATH.

	* src/devices/grops/grops.man: Document GROFF_FONT_PATH and
	old font description files.

	* font/devps/Makefile.sub (OLDDISTFILES, OLDDEVFILES): New
	variables.

	* font/devps/old/*: New directory, holding the previous version
	of the 35 Adobe core font description files.

	* font/devps/*: Regenerated the 35 Adobe core fonts, using the
	Adobe-Core35_AFMs-229.tar.bz2 bundle from ftp.dante.de.

	* NEWS: Document font update.

2006-12-31  Werner LEMBERG  <wl@gnu.org>

	* font/devps/generate/Makefile (symbolsl.afm): Use $(srcdir).

	* Makefile.comm (fonts): New (empty) target.
	* Makefile.in (TARGETS): Add `fonts'.

	* MANIFEST: Add `chem'.

	* doc/groff.texinfo (Changing Fonts): Font translations with .ftr
	can't be chained.

2006-12-26  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/grn/hdb.cpp: Include gprint.h later.  From NetBSD.

2006-12-19  Werner LEMBERG  <wl@gnu.org>

	Add support for German.  For activation, simply use -mde or -mden
	(for traditional and new orthgraphy, respectively) as the last
	macro package.

	* tmac/de.tmac, tmac/den.tmac, tmac/hyphen.det, tmac/hyphen.den,
	tmac/hyphenex.det: New files, partly taken from CTAN.
	* LICENSES: Updated list of hyphenation patterns.
	* man/groff_tmac.man: Mention de.tmac and den.tmac.
	* NEWS: Updated.

2006-12-11  Werner LEMBERG  <wl@gnu.org>

	Support up to 32 macro arguments in pic (and up to 16 on EBCDIC
	hosts).

	* src/preproc/pic/lex.cpp (ARG1): Redefine.  Update all users.
	(MAX_ARG): New macro.  Use it everywhere to replace hard-coded
	limit of 9 arguments.
	(process_body): Handle argument numbers with more than a single
	digit.
	(interpolate_macro_with_args): Protect against exceeding number of
	arguments.

	* NEWS, src/preproc/pic/pic.man, doc/pic.ms: Document it.

2006-12-10  Werner LEMBERG  <wl@gnu.org>

	* Makefile.in (site.exp, docheck): Commented out.  Not working
	currently.
	(check): Just emit dummy message.

2006-12-08  Werner LEMBERG  <wl@gnu.org>

	During installation, create soft link from <version> to `current' in
	<datadir>/groff.

	* Makefile.comm (install): Renamed to...
	(do_install): This.
	(prefix_must_exist): Removed.  Code moved to Makefile.in.

	* Makefile.in (TARGETS): Remove `install'.

	(install): New target which first creates the directory given by
	--prefix, then calling `make' to do the installation, and finishing
	with the creation of the soft link.

2006-11-21  Werner LEMBERG  <wl@gnu.org>

	* doc/Makefile.sub (uninstall_sub): Fix names for info files.

2006-11-18  Werner LEMBERG  <wl@gnu.org>

	* man/roff.man, doc/groff.texinfo: Improve history of roff, based on
	information from Tom Van Vleck <thvv@multicians.org>.

2006-11-16  Werner LEMBERG  <wl@gnu.org>

	* tmac/62bit.tmac: New macro package.
	* tmac/Makefile.sub (NORMALFILES): Add it.
	* NEWS: Document it.

	* tmac/trace.tmac: Protect against being loaded again.
	(nr): Always show result.

	* doc/groff.texinfo (Input Encodings): Document latin-5.

	* man/grof_tmac.man: Document sv, latinX, cp1047, 60bit, ec.

2006-11-13  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo (Page Location Traps) [.wh]: Give more details
	on negative trap positions.

2006-11-10  Werner LEMBERG  <wl@gnu.org>

	* Makefile.comm (.man.n): Handle @DATASUBDIR@.

2006-11-09  Werner LEMBERG  <wl@gnu.org>

	* INSTALL: Move information about external installation from
	INSTALL.gen into this file.
	Updated.

	* INSTALL.gen: Update to new version (from texinfo CVS).

2006-11-09  Bernd Warken <groff-bernd.warken-72@web.de>

	* INSTALL.gen: Extend the file by information on `external
	installation'.  Reorder the installation instruction as `normal
	installation'.

2006-11-08  Werner LEMBERG  <wl@gnu.org>

	* doc/Makefile.sub (install_data): Take care of proper paths while
	installing info files.  Bug reported by
	Bernd Warken <groff-bernd.warken-72@web.de>.

2006-11-06  Bernd Warken <groff-bernd.warken-72@web.de>

	* src/roff/grog/grog.pl: Rewrite.
	- Call by `#! /usr/bin/env perl'.  That isn't replaced.
	- Rename usage() to version().
	- Use warnings.
	- For `use strict', start all global variables with an upper case
	character.  Use `my' for all variables.  Use several new variables.
	- Add option `-h'.
	- Add copyright to GPL and Emacs comment.
	- Handle several `-m*' options.
	- Fix handling of `-ms' and `-mm'.  Add .TL and .NH.
	- Allow options after file names.
	- Allow only one `-' parameter (standard input).
	- Add option abbreviations.
	- Expand the usage information.
	- Add `chem'.
	- Add single quote "'" as additional first character and allow
	arbitrary space after the first character.

	* src/roff/grog/grog.sh: Rewrite.
	- Remove option `-e' of `sed'.
	- Allow file names with space characters.
	- Add option `-h'.
	- Add copyright to GPL.
	- Handle several `-m*' options.
	- Fix handling of `-ms' and `-mm'.  Add .TL and .NH.
	- Allow options after file names.
	- Allow only one `-' parameter (standard input).
	- Add option abbreviations.
	- Expand the usage information.
	- Add `chem'.
	- Add single quote "'" as additional first character and allow
	arbitrary space after the first character.

	* src/roff/grog/Makefile.sub:
	- Add copyright to GPL.
	- Remove `grog:'.  Move `grog.old:' to `grog:' in order to have a
	fair chance to choose between the shell version and the Perl
	version of `grog'.  This is now again comparable to grog in groff
	version 1.10.

	* src/roff/grog/grog.man: Rewrite.
	- Move the license to GPL.
	- New sections: OPTIONS, DETAILS, EXAMPLES, COPYING.
	- Take over some setup and macros from `groffer'.
	- Add information on options.

2006-10-28  Werner LEMBERG  <wl@gnu.org>

	* tmac/trace.tmac: Improve tracing of `.nr'.
	Trace `.substring' also.

	* NEWS: Updated.

2006-10-28  Bernd Warken <groff-bernd.warken-72@web.de>

	* man/roff.man, src/roff/groff/groff.man: Add `chem', fix position
	of groff development site, fix fonts.

	* News: Add information on `chem' and `groffer'.

2006-10-26  Bernd Warken <groff-bernd.warken-72@web.de>

	* Makefile.in (OTHERDIRS, NOMAKEDIRS): Add `chem' bundle.

2006-10-26  Werner LEMBERG  <wl@gnu.org>

	Add `\$^' escape to handle the parameters to a macro as a string
	argument.

	* src/roff/troff/input.h (DOUBLE_QUOTE): New special character.

	* src/roff/troff/input.cpp (input_iterator, input_stack,
	macro_iterator): Add `space_follows_arg' member function.
	(macro_iterator::add_arg): Add parameter to set the `space_follows'
	flag.
	(arg_list): Add member `space_follows'.
	Update constructor and all callers.
	(decode_args): Store discarded double quotes.
	(interpolate_args): Handle DOUBLE_QUOTE.
	Add `\$^' escape.
	(get_copy, token::next, composite_glyph_name): Handle DOUBLE_QUOTE.

	* tmac/trace.tmac: Trace .nr, .ds, .ds1, .as, .as1.

	* docs/groff.texinfo (Parameters), man/groff.man,
	man/groff_diff.man, NEWS: Document it.

2006-10-24  Bernd Warken <groff-bernd.warken-72@web.de>

	* Makefile.in (NOMAKEDIRS): Add groffer subdirectories.

2006-10-24  Werner LEMBERG  <wl@gnu.org>

	* tmac/groff_trace.man: Mention problem with `\\\\'.

2006-10-23  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo (Expressions): Improve documentation of `!'.

	* tmac/trace.tmac (return): Don't call `substring'.

2006-09-10  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cpp (read_size): Revert previous change
	w.r.t. `\s-[-...]'.

	* doc/groff.texinfo (Fractional Size Types): Clarify syntax of \s.

2006-09-09  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cpp (read_size): Fix `\s[-\n[.s]]' so that it
	behave the same as `\s-[\n[.s]]' (this is, emit a warning and set
	point size to 1).  Reported by Gunnar Ritter.
	Also catch `\s-[-...]' and friends (causing an error).

2006-09-06  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/env.cpp (environment::do_break): Insert zero-width
	space only if there is no previous space.  This fixes a bug which
	caused unwanted filling of the last line in a paragraph.  Thanks to
	Gunnar Ritter for an analysis.

2006-09-03  Werner LEMBERG  <wl@gnu.org>

	* src/roff/groff/groff.cpp (main): Pass -U flag to pic also.
	Reported by Jennifer Sayers <jenjen@isu.usyd.edu.au>.

2006-09-01  Nick Stoughton  <nick@msbit.com>
	    Werner LEMBERG  <wl@gnu.org>

	Add a request `pev' to print environment information (similar to
	`pnr' and `ptr' to print number registers and traps).

	* src/roff/troff/env.h (environment): Add member function print_env.

	* src/roff/troff/env.cpp: (environment::print_env): New function to
	print a given environment state.
	(print_env): New global function to iterate through the
	environments, printing each one.
	(init_env_requests): Register `pev'.

	* doc/groff.texinfo (Debugging), man/groff.man, man/groff_diff.man,
	NEWS: Document `pev' request.

2006-09-01  Bernd Warken <groff-bernd.warken-72@web.de>

	* src/preproc/soelim/soelim.cpp (usage): Fix option argument of
	`-I' to	`dir'.

2006-09-01  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/pic/main.cpp (usage): Add missing options.

2006-08-25  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/soelim/soelim.man: Document how to insert `\' and ` '
	in file names.

2006-08-19  Werner LEMBERG  <wl@gnu.org>

	* configure: Regenerated.

2006-08-18  Keith Marshall  <keith.d.marshall@ntlworld.com>

	* m4/groff.m4 (GROFF_MAKEINFO): Correct `makeinfo version testing
	logic; it previously caused an `expr' syntax error, if no version of
	`makinfo' was present.  Also, remove dependency on `makeinfo' in VPATH
	builds, if an up to date `groff.info' is present in either `builddir'
	or in `srcdir'.

2006-08-12  Tadziu Hoffmann  <hoffmann@usm.uni-muenchen.de>

	* font/devps/prologue.ps: Add BPhook.

	* src/devices/grops/grops.man: Document BPHook.
	Reorder some sections for better readability.

2006-08-12  Werner LEMBERG  <wl@gnu.org>

	* src/include/lib.h (getlocale): New macro.
	(setlocale, LC_ALL, LC_CTYPE) [!HAVE_SETLOCALE]: Define, as
	suggested by Bruno.

	* src/preproc/preconv/preconv.cpp (main): Use getlocale.

2006-08-11  Werner LEMBERG  <wl@gnu.org>

	Add new flag to .cflags to enable hyphenation without looking at
	hcode values.

	* src/roff/troff/charinfo.h (charinfo): New enumeration value
	`IGNORE_HCODES'.
	New member function `ignore_hcodes'.

	* src/roff/troff/node.cpp (break_char_node::add_self,
	node::add_char): Updated.

	* doc/groff.texinfo, man/groff_diff.man, NEWS: Document it.

2006-08-09  Werner LEMBERG  <wl@gnu.org>

	Support composite Unicode characters again.  Reported by Colin.

	* font/devhtml/R.proto: Renamed to...
	* font/devhtml/R.in: This.

	* font/devutf8/R.proto: Renamed to...
	* font/devutf8/R.in: This.
	Add `charset' line.

	* font/make-Rproto: New script.
	* font/devhtml/R.proto, font/devutf8/R.proto: Generated.

2006-07-26  Werner LEMBERG  <wl@gnu.org>

	* README: Fix description of CVS access.  Reported by Joachim.

2006-07-11  Werner LEMBERG  <wl@gnu.org>

	Add a request `.fzoom' and a number register `.zoom' to magnify
	fonts.

	* src/include/font.h (font): Add member variable `zoom'.
	Add member functions `set_zoom' and `get_zoom'.
	Remove `static' attribute from `scale' member function.

	* src/libs/libgroff/font.cpp (font::font): Updated.
	(scale_round): New version with three parameters to handle zoom
	factor.
	(font::scale, font::get_width): Handle zoom factor.
	(font::set_zoom, font::get_zoom): New functions.
	(font::load): Handle `zoom' while computing `space_width'.

	* src/roff/troff/env.h: Declare `env_get_zoom'.
	(environment): Add member function `get_zoom'.

	* src/roff/troff/env.cpp (environment::get_zoom): New function.
	(init_env_requests): Initialize `.zoom' register.

	* src/roff/troff/node.cpp (font_info): New member functions
	`set_zoom' and `get_zoom'.
	(tfont): New member function `get_zoom'.
	(env_get_zoom): New function.
	(troff_output_file::set_font): Handle zoom factor.
	(font_zoom_request): New function.
	(init_node_requests): Initialize `fzoom' request.

	* docs/groff.texinfo (Changing Fonts), man/groff.man,
	man/groff_diff.man, NEWS: Document `fzoom' request and `.zoom'
	register.

	* src/roff/troff/TODO: Updated.

2006-07-10  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo (Drawing Requests): Improve documentation of
	\D'P ...'.

2006-07-02  Werner LEMBERG  <wl@gnu.org>

	* man/groff_tmac.man: Document usage of .PSPIC within diversions.

2006-07-01  Werner LEMBERG  <wl@gnu.org>

	* tmac/pspic.tmac: Make .PSPIC work for all devices.
	Print image file name for devices which don't support PS image
	inclusion.
	Handle multiple inclusions.
	Add lots of comments.

	* tmac/dvi.tmac, tmac/html.tmac, tmac/ps.tmac: Don't load
	pspic.tmac.

	* tmac/troffrc: Load pspic.tmac.

	* man/groff_tmac.man: Update .PSPIC documentation.

	* NEWS: Updated.

2006-06-29  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cpp (interpolate_macro):
	s/probably/possibly/, as suggested by Keith.

2006-06-28  Werner LEMBERG  <wl@gnu.org>

	Add support for \D'p...' to grotty.

	* src/devices/grotty/grotty.cpp (tty_printer::draw): Move most of
	its code to...
	(tty_printer::line): This function.
	(tty_printer::draw): Rewritten; just call either draw_line or
	draw_polygon.
	(tty_printer::draw_line, tty_printer::draw_polygon): New functions.

	* src/devices/grotty/grotty.man, NEWS: Document it.

2006-06-27  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/refer/command.h (have_bibliography): New variable
	declaration.

	* src/preproc/refer/command.cpp (bibliography_command): Set
	`have_bibliography'.

	* src/preproc/refer/refer.cpp: Initialize `have_bibliography'.
	(output_references): Emit warning only if `have_bibliography' is
	set.

2006-06-15  Michail Vidiassov  <master@iaas.msu.ru>

	* font/devps/Makefile.sub (DISTFILES): Add freeeuro.afm.
	* font/devps/generate/Makefile (clean): Don't remove symbolsl.afm
	and zapfdr.afm.

2006-06-15  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/tbl.man: Document limitations of .TS/.TE within a
	macro (as suggested by Tadziu Hoffmann).

2006-06-12  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/tbl.man: Add example for use of .TS/.TE within a
	macro (as suggested by Tadziu Hoffmann).

2006-06-05  Werner LEMBERG  <wl@gnu.org>

	* tmac/strip.sed: Strip `\#' also.

	* doc/groff.texinfo (Operators in Conditionals): Document usage of
	\? for string comparison.

2006-06-04  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Add more index entries for copy-in mode.
	(Changing Fonts) <.ft>: Document that a font definition file must
	not be called `DESC'.

2006-05-31  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cpp (token::next) <\N>: Catch negative values
	here.

	* doc/Makefile.sub (EXAMPLEFILES): Move gnu.eps to...
	(PROCESSEDEXAMPLEFILES): Here.

2006-05-30  Werner LEMBERG  <wl@gnu.org>

	* src/libs/libgroff/font.cpp (font::load): Reject fonts called
	`DESC'.
	Reduce number of false positives for `.if F ...' conditionals.
	Improve warning messages.

2006-05-29  Werner LEMBERG  <wl@gnu.org>

	* tmac/Makefile.sub: Add copyright notice.
	(NORMALFILES): Add man.tmac and ms.tmac.
	(SPECIALFILES): Remove man.tmac and ms.tmac.
	(CLEANADD): Remove man.tmac-sed and ms.tmac-sed.
	(install_data, uninstall_sub): Don't handle man.tmac and ms.tmac
	specially.
	(stamp-sed): Don't handle man.tmac and ms.tmac.
	Remove obsolete components in sed's regexp.

	* doc/Makefile.sub (EXAMPLEFILES): Add gnu.eps.

	* Makefile.in (OTHERDIRS, NOMAKEDIRS): Add hdtbl.

2006-05-28  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo (History): Correct death circumstances of Joe
	Ossanna.

2006-05-27  Werner LEMBERG  <wl@gnu.org>

	* tmac/an-old.tmac (an-do-tag): Simplify.

2006-05-26  Werner LEMBERG  <wl@gnu.org>

	* tmac/an-old.tmac (an-do-tag): Make margin characters work.
	(an-header, an-p-footer): Use named environment.

	* src/roff/troff/env.cpp (environment::copy): Copy margin character
	node.

2006-05-21  Werner LEMBERG  <wl@gnu.org>

	* tmac/trace.tmac (de1): Fix serious typo (.di -> .do) and minor
	omissions.

2006-05-11  Keith Marshall  <keith.d.marshall@ntlworld.com>

	* src/roff/groff/groff.man: Remove superfluous word `intermediate'.

2006-05-10  Keith Marshall  <keith.d.marshall@ntlworld.com>

	* src/roff/groff/groff.man: Update copyright notice.
	Improved wording to describe effect of `-Z' option.

2006-05-06  Werner LEMBERG  <wl@gnu.org>

	* tmac/www.tmac: Decorate `.ds' with trailing `\"' where missing.
	Normalize handling of `"' in arguments.
	(PIMG): Remove debug message.
	Simplify code.

2006-05-05  Werner LEMBERG  <wl@gnu.org>

	* src/devices/grohtml/post-html.cpp (page::add_and_encode): Don't
	swallow character immediately after `\[...]'.
	Simplify code.

2006-05-02  Gaius Mulley  <gaius@glam.ac.uk>

	* tmac/www.tmac (PIMG): Fix the HTML device specific components.

2006-05-02  Larry Kollar  <kollar@alltel.net>

	* tmac/www.tmac (PIMG): Really default to `-C' if the alignment
	option is missing.

2006-04-30  Michail Vidiassov  <master@iaas.msu.ru>

	* src/utils/afmtodit/afmtodit.pl: New option `-c' to add font
	information as a comment in output.
	* src/utils/afmtodit/afmtodit.man, NEWS: Document it.

2006-04-26  Werner LEMBERG  <wl@gnu.org>

	* src/devices/grohtml/post-html.cpp (html_printer::~html_printer):
	Handle current_paragraph only if it is non-NULL.

	* src/libs/libdriver/input.cpp (parse_x_command <'F'>, do_file
	<'F'>): Use `get_extended_arg' to behave as documented.  Reported by
	Bill Ward <william.a.ward.jr@erdc.usace.army.mil>.


	Surround the (pseudo) file name for the .pso request with `<' and
	`>'.

	* src/roff/troff/node.cpp (real_output_file, troff_output_file): Add
	second parameter to `really_put_filename' and `put_filename'.
	(troff_output_file::really_put_filename): Emit `<' and `>' around
	filename if second argument is set.
	* src/roff/troff/node.h: Updated.

	* src/roff/troff/input.cpp (file_iterator::file_iterator,
	file_iterator::set_location): Update to changes in node.cpp.

2006-04-25  Tetsurou Okazaki  <okazaki@FreeBSD.org>

	* src/preproc/preconv/preconv.cpp (do_file): Fix conditional
	preprocessor expression (I18N -> HAVE_ICONV).
	(main): Fix handling of option `-h'.
	Fix conditional preprocessor expression.

2006-04-04  Werner LEMBERG  <wl@gnu.org>

	Implement new number register `.br' which is set to 1 if a macro has
	been called as .foo and to 0 if called as 'bar.  This is useful for
	-mtrace so that requests can be reliably traced too.

	* src/roff/troff/input.cpp (input_iterator): Add virtual function
	`get_break_flag'.
	(macro_iterator): Add `with_break' member and `get_break_flag'
	function.
	Update constructors.
	(input_stack): Add function `get_break_flag'.
	(break_flag_reg): New number register class.
	(input_init_requests): Register `.br'.

	* src/roff/troff/TODO: Updated.

	* tmac/trace.tmac: s/!!sp/!!!sp/.
	Modify definitions of `de', `de1', `am', and `am1' to use \n[.br].

	* docs/groff.texinfo (Requests), man/groff.man, man/groff_diff.man,
	NEWS: Document it.

2006-03-29  Werner LEMBERG  <wl@gnu.org>

	* src/devices/grops/ps.cpp: s/must not/should not/ in warning
	messages where appropriate.

2006-03-28  Werner LEMBERG  <wl@gnu.org>

	* configure.ac: Call AC_PROG_EGREP.
	* configure: Regenerated.

	* Makefile.in (EGREP): New variable.
	(MDEFINES): Add $(EGREP).

	* src/roff/grog/grog.sh: Treat .TH between .TS and .TE properly
	(bug reported by Robert Goulding <Goulding.2@nd.edu>).
	Use @EGREP@.

	* src/roff/grog/Makefile.sub (grog, grog.old): Use $(EGREP).

2006-03-27  Werner LEMBERG  <wl@gnu.org>

	Add two requests `.device' and `.devicem' which are equivalent to
	`\X' and `\Y', respectively.

	* src/roff/troff/input.cpp (device_request, device_macro_request):
	New functions.
	(init_input_requests): Register them.

	* doc/groff.texinfo (Postprocessor Access), man/groff_diff.man,
	man/groff.man, NEWS: Document them.

2006-03-27  Gaius Mulley  <gaius@glam.ac.uk>

	* src/roff/troff/input.cpp (encode_char): Emit special characters
	for -Thtml as `\[...]'.
	* src/devices/grohtml/post-html.cpp (page::add_and_encode): Updated.

	* doc/groff.texinfo (Postprocessor Access) <\X>: Updated.

2006-03-27  Werner LEMBERG  <wl@gnu.org>

	* tmac/Makefile.sub (NORMALFILES, SPECIALFILES): Add various missing
	files.

2006-03-26  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo (Writing Macros): More documentation on
	end-of-macro symbol of `.de'.
	(Diversions): Minor addition to `.di' description.

	* src/devices/grops/grops.man: Some clarifications regarding
	insertion of PostScript snippets.

2006-03-25  Michail Vidiassov  <master@iaas.msu.ru>

	Add rules to generate `symbolsl.afm'.

	* font/devps/generate/zapfdr.sed,
	font/devps/generate/symbolsl.awk: New files.

	* font/devps/generate/Makefile (symbolfont, PRINTAFM): New
	variables.
	(SS, clean): Updated.
	(freeeuro.afm): Use $(srcdir).
	(symbolsl.afm): New rule.
	(zapfdr.afm): Use zapfdr.sed.

2006-03-22  Dwight Aplevich  <aplevich@uwaterloo.ca>

	* src/preproc/pic/pic.y (expr <INT>): Fix code.

2006-03-22  Jörgen Grahn <jgrahn@algonet.se>

	* tmac/sv.tmac: Add missing translations and activate support for
	other macro packages.

2006-03-21  Francis GUDIN  <fgudin@nerim.net>

	* tmac/doc-syms (Dx): New macro to identify DragonFly.
	(doc-str-St--ieee1275-94, doc-str-St--isoC-amd1,
	doc-str-St--isoC-tcor1, doc-str-St--isoC-tcor2): New standard
	strings.
	(doc-operating-system-FreeBSD-5.5, doc-operating-system-FreeBSD-7.0,
	doc-operating-system-NetBSD-1.6.3, doc-operating-system-NetBSD-4.0
	doc-operating-system-DragonFly-*): New operating system strings.

	* tmac/groff_mdoc.man, NEWS: Document `Dx'.

2006-03-21  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/pic/pic.y (object_spec THEN): For compatibility with
	both DWB pic and dpic, make

	  right;
	  line then down;

	equal to

	  right;
	  line right then down;

	instead of

	  right;
	  line 0 then down;

	* doc/pic.ms: Document this.

2006-03-20  Werner LEMBERG  <wl@gnu.org>

	* doc/pic.ms: With permission of Eric Raymond, put it under the
	GPL.

	* NEWS: Updated.

2006-03-19  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/pic/pic.y (expr <INT>): Really return integer part.

	* src/preproc/pic/objects.cpp (object_spec::make_line): Handle `at'
	attribute in combination with `with'.  Bug reported by Jennifer
	Sayers <jenjen@mail.usyd.edu.au>.

2006-03-19  Miklos Somogyi  <msom@netspace.net.au>

	* doc/groff.texinfo (Manipulating Spacing): Improve documentation of
	`.sp'.

2006-03-18  Werner LEMBERG  <wl@gnu.org>

	* LICENSE: Renamed to...
	* LICENSES: This.  Collect all licensing information in this file.
	* tmac/README, src/libs/snprintf/README: Removed.

	* src/devices/grops/grops.man: Add section how to install fonts.

	* src/utils/xtotroff/xtotroff.c: Add GPL.

2006-03-17  Werner LEMBERG  <wl@gnu.org>

	* Makefile.comm (.y.cpp): Fix #line arguments in output.

2006-03-13  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/tbl/tbl.man: Mention default length of text blocks.

	* tmac/doc-common (Os): Add more Darwin versions.
	* tmac/groff_mdoc.man: Document them.

	* doc/groff.texinfo (Operators in Conditionals): Mention that `c'
	works with \N'...' also.
	* man/groff_diff.man: Ditto.  Remove use of future tense where
	possible.

2006-03-12  Michail Vidiassov  <master@iaas.msu.ru>

	* font/devps/generate/make-zapfdr, font/devps/symbolsl.ps,
	font/devps/zapfdr.ps: Add `%%EndComments' line.

2006-03-10  Larry Kollar  <kollar@alltel.net>

	* doc/groff.texinfo (Headers and footers): Document PT, HD, and BT.

2006-03-10  Werner LEMBERG  <wl@gnu.org>

	* src/devices/grops/ps.cpp (ps_printer::do_exec, ps_printer::do_def,
	ps_printer::do_mdef): Overlong lines now cause a warning message,
	not an error.

2006-03-09  Werner LEMBERG  <wl@gnu.org>

	* font/devps/generate/make-zapfdr: New script for generating
	`zapfdr.ps'.

2006-03-08  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.css (pre): Fix `background-color' value.

2006-03-04  Larry Kollar  <kollar@alltel.net>

	* tmac/groff_ms.man: Document PT, HD, and BT.

2006-03-04  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/node.cpp (make_glyph_node): Improve warning message
	for single-letter glyph names.

2006-03-02  Werner LEMBERG  <wl@gnu.org>

	* tmac/sv.tmac: New file; currently holding only the Swedish strings
	for -mm.
	* tmac/hyphen.sv: New hyphenation pattern file for Swedish, taken
	from CTAN.
	* tmac/README: Updated.

2006-02-27  Werner LEMBERG  <wl@gnu.org>

	* tmac/trans.tmac (Liec, Letdate, Letns!14): Add it (for -mm).
	* tmac/fr.tmac: Add French translations.

	* tmac/composite.tmac: Add entry for `:'.

2006-02-26  Werner LEMBERG  <wl@gnu.org>

	* doc/Makefile.sub (HTMLEXAMPLEFILESALL): New variable.
	(CLEANADD): Use it.
	(install_html, uninstall_sub): Updated.

2006-02-26  Bruno Haible  <bruno@clisp.org>

	Introduce Unicode fonts.

	* font/devhtml/DESC.proto: Mark as unicode.
	* font/devhtml/R.proto: Remove all charset entries that are already
	in glyphuni.cpp.
	* font/devutf8/DESC.proto: Mark as unicode.
	* font/devutf8/R.proto: Remove all charset entries.
	* src/include/font.h (font): New static field `is_unicode'.
	Change order of fields.
	* src/libs/libgroff/font.cpp: Include unicode.h.
	(font::font): Update for changed order of fields.
	(font::contains, font::get_width, font::get_height, font::get_depth,
	font::get_italic_correction, font::get_left_italic_correction,
	font::get_subscript_correction, font::get_character_type,
	font::get_code, font::get_special_device_encoding): Handle both the
	explicitly enumerated glyphs and use general code for Unicode fonts.
	(font::load): Make the charset section optional when the font is
	declared unicode.
	(font::load_desc): Recognize the `unicode' attribute.
	* src/libs/libgroff/fontfile.cpp (font::is_unicode): New variable.

2006-02-26  Claudio Fontana  <claudio@gnu.org>

	* Makefile.in: Add comment about DESTDIR.

	* Makefile.sub: Add DESTDIR to install and uninstall targets
	to support staged installations.
	* Makefile.comm: Likewise.
	* doc/Makefile.sub: Likewise.
	* contrib/eqn2graph/Makefile.sub: Likewise.
	* contrib/grap2graph/Makefile.sub: Likewise.
	* contrib/pic2graph/Makefile.sub: Likewise.
	* src/devices/xditview/Makefile.sub: Likewise.
	* src/preproc/eqn/Makefile.sub: Likewise.
	* src/roff/grog/Makefile.sub: Likewise.
	* src/roff/nroff/Makefile.sub: Likewise.
	* src/utils/afmtodit/Makefile.sub: Likewise.
	* src/utils/indxbib/Makefile.sub: Likewise.
	* tmac/Makefile.sub: Likewise.

2006-02-24  Werner LEMBERG  <wl@gnu.org>

	* src/libs/libgroff/glyphuni.cpp (glyph_to_unicode_list): Use entry
	for \-.
	Remove commented out entries for \' and \` (there are no such glyph
	names).

	* src/libs/libgroff/uniglyph.cpp (unicode_to_glyph_list): Remove
	commented out entries for \' and \`.


	* */*: s/legal/valid/ where appropriate.

2006-06-23  Werner LEMBERG  <wl@gnu.org>

	* font/devhtml/R.proto, font/devutf8/R.proto: Remove incorrect \'
	and \` entries.

2006-02-22  Werner LEMBERG  <wl@gnu.org>

	Remove all remaining traces from the `shc' glyph.

	* src/libs/libgroff/glyphuni.cpp (glyph_to_unicode_list),
	src/libs/libgroff/uniglyph.cpp (unicode_to_glyph_list): Remove
	entry for `shc'.

	* font/devlatin1/R.proto, font/devcp1046/R.proto: Replace `shc'
	entry with unnamed glyph.

	* tmac/html/tmac: Remove `shc' entry from call to `.cflags'.

	* src/preproc/preconv/preconv.cpp (unicode_entity): Handle U+00AD
	specially.

2006-02-22  Bruno Haible  <bruno@clisp.org>

	Concretize the `glyph' datatype.

	* src/include/font.h (glyph): Remove class.
	(glyph): Renamed from struct `glyphinfo'.
	(glyph_to_index): New inline function.
	(glyph_to_name): Make extern, not inline.
	(glyph_to_number): Update.
	(font): Use `glyph *' instead of `glyph'.

	* src/libs/libgroff/nametoindex.cpp (charinfo): Inherit from class
	`glyph'.  Make `name' field public.
	(character_indexer, number_to_glyph, name_to_glyph): Use `glyph *'
	instead of `glyph'.
	(glyph_to_name): Renamed from `glyph::glyph_name'.

	* src/roff/troff/charinfo.h (charinfo): Inherit from class `glyph'.
	Use `glyph *' instead of `glyph'.

	* src/roff/troff/input.cpp (name_to_glyph, number_to_glyph): Use
	`glyph *' instead of `glyph'.
	(glyph_to_name): Renamed from `glyph::glyph_name'.

	* src/libs/libgroff/font.cpp: Use `glyph *' instead of `glyph',
	and `glyph_to_index' instead of `glyph::glyph_index'.

	* src/include/printer.h (printer): Use `glyph *' instead of `glyph'.
	* src/libs/libdriver/printer.cpp: Likewise.
	* src/devices/grodvi/dvi.cpp: Likewise.
	* src/devices/grohtml/post-html.cpp: Likewise.
	* src/devices/grolbp/lbp.cpp: Likewise.
	* src/devices/grolj4/lj4.cpp: Likewise.
	* src/devices/grops/ps.cpp: Likewise.
	* src/devices/grotty/tty.cpp: Likewise.

2006-02-22  Werner LEMBERG  <wl@gnu.org>

	* font/devdvi/generate/tc.map: Add `sr' glyph.
	* font/devdvi/*TC: Regenerated.

	* src/libs/libgroff/glyphuni.cpp (glyph_to_unicode_list): Use entry
	for `sqrt'.

2006-02-21  Werner LEMBERG  <wl@gnu.org>

	* man/groff_char.man: Explain `***' marker.

2006-02-17  Bruno Haible  <bruno@clisp.org>

	* src/libs/libgroff/nametoindex.cpp (character_indexer): Rename
	methods and fields from *_index to *_glyph.
	(character_indexer::named_char_glyph): Test for `charNNN' name
	here...
	(name_to_glyph): ... not here.

2006-02-17  Bruno Haible  <bruno@clisp.org>

	* src/include/font.h (name_to_glyph): Renamed from
	font::name_to_index.
	(number_to_glyph): Renamed from font::number_to_index.
	(glyph_to_name): Renamed from font::index_to_name.
	(glyph_to_number): Renamed from font::index_to_number.
	* src/libs/libgroff/nametoindex.cpp: Likewise.
	* src/roff/troff/charinfo.h (charinfo::as_glyph): Renamed from
	charinfo::get_index.

	* src/roff/troff/input.cpp: All callers changed.
	* src/roff/troff/node.cpp: Likewise.
	* src/libs/libgroff/font.cpp: Likewise.
	* src/devices/grops/ps.cpp: Likewise.
	* src/devices/grohtml/post-html.cpp: Likewise.
	* src/libs/libdriver/printer.cpp: Likewise.

2006-02-17  Werner LEMBERG  <wl@gnu.org>

	* src/include/ptable.h, src/include/itable.h
	(NEXT_PTABLE_SIZE_DEFINED): Use it to avoid multiple declaration
	of external symbol `next_ptable_size' (used by both header files).

2006-02-15  Bruno Haible  <bruno@clisp.org>

	* src/include/font.h (glyphinfo): New class.
	(glyph): Change internal representation.
	Change constructor signature.
	New method glyph::glyph_number().
	(glyph::glyph, glyph glyph::undefined_glyph, glyph::glyph_index,
	glyph::operator==, glyph::operator!=): Update.
	(font::index_to_name, font::index_to_number): New functions.

	* src/include/itable.h: New file, based on src/include/ptable.h.

	* src/libs/libgroff/nametoindex.cpp: Include itable.h.
	(class charinfo): New class.
	(class character_indexer): Change table result type from `int' to
	`class charinfo'.
	Add table with integer key.
	(character_indexer::character_indexer): Update.
	(character_indexer::ascii_char_index): Update.
	(character_indexer::numbered_char_index): Use NULL as name, not a
	string starting with a space.
	(character_indexer::named_char_index): Update.
	(font::number_to_index, font::name_to_index): Remove no-op cast.
	(glyph::glyph_name): New method.
	* src/roff/troff/charinfo.h (class charinfo): Inherit from class
	glyphinfo.
	(NUMBERED): Remove flag bit.
	(charinfo::numbered, charinfo::get_index): Update.

	* src/roff/troff/input.cpp (charinfo::charinfo): Update.
	(charinfo::set_number, charinfo::get_number): Update.
	(glyph::glyph_name): New method.

2006-02-15  Werner LEMBERG  <wl@gnu.org>

	* src/libs/libgroff/glyphuni.cpp (glyph_to_unicode_list): Fix
	entries for `>>', `<<', `*f', and `+f'.  Reported by Bruno.

2006-02-13  Werner LEMBERG  <wl@gnu.org>

	* font/devps/prologue.ps (RE): Check `UniqueID' also, similar to
	dvips.

2006-02-11  Werner LEMBERG  <wl@gnu.org>

	* src/include/font.h: s/glyph_t/glyph/.
	Update all callers.

	* src/devices/grotty/tty.cpp: s/glyph/tty_glyph/.
	s/output_character_t/output_character/.

2006-02-11  Bruno Haible  <bruno@clisp.org>

	New accessor method glyph_t::glyph_name().

	* src/include/ptable.h (declare_ptable): Add a return value to the
	`define' method, and declare a `lookupassoc' method.
	(implement_ptable): Return the stored key in `define'.  Implement
	lookupassoc.
	* src/include/font.h (glyph_t): Add `name' field.  Add an argument
	to the constructor.
	(glyph_t::glyph_name): New method.

	* src/libs/libgroff/nametoindex.cpp (character_indexer): Change
	return type of methods and field member type to glyph_t.
	(character_indexer::character_indexer): Update.
	(character_indexer::ascii_char_index): Allocate a name for the
	glyph.
	Return a glyph_t with name.
	(character_indexer::numbered_char_index): Return a glyph_t without a
	name.
	(character_indexer::named_char_index): Return a glyph_t with a name.
	(font::number_to_index, font::name_to_index): Update.

	* src/roff/troff/input.cpp (charinfo::charinfo): Use the symbol as
	the glyph's name.

2006-02-11  Bruno Haible  <bruno@clisp.org>

	* src/devices/grotty/tty.cpp (output_character_t): New type.
	(tty_printer::make_bold, tty_printer::add_char,
	tty_printer::put_char): Change argument type to output_character_t.
	(crossings): Change element type to output_character_t.

2006-02-11  Bruno Haible  <bruno@clisp.org>

	Make the glyph data type abstract.

	* src/include/font.h (glyph_t): New class.
	(name_to_index, number_to_index): Change return type to glyph_t.
	(font::contains, font::get_width, font::get_height, font::get_depth,
	font::get_character_type, font::get_kern, font::get_skew,
	font::get_italic_correction, font::get_left_italic_correction,
	font::get_subscript_correction, font::get_code,
	font::get_special_device_encoding, font::add_entry,
	font::copy_entry, font::add_kern, font::hash_kern): Change argument
	type to glyph_t.

	* src/libs/libgroff/font.cpp (font_kern_list): Change members
	type and constructor argument types to glyph_t.
	(font::contains, font::get_width, font::get_height, font::get_depth,
	font::get_character_type, font::get_kern, font::get_skew,
	font::get_italic_correction, font::get_left_italic_correction,
	font::get_subscript_correction, font::get_code,
	font::get_special_device_encoding, font::add_entry,
	font::copy_entry, font::add_kern, font::hash_kern): Change argument
	type to glyph_t.
	(font::load): Use glyph_t variables.

	* src/libs/libgroff/nametoindex.cpp (name_to_index,
	number_to_index): Change return type to glyph_t.

	* src/roff/troff/charinfo.h (charinfo::index): Change type to
	glyph_t.
	(charinfo::get_index): Change return type to glyph_t.

	* src/roff/troff/env.cpp: Include font.h.

	* src/roff/troff/node.cpp: Include font.h before charinfo.h.

	* src/roff/troff/input.cpp: Include font.h before charinfo.h.
	(charinfo::charinfo): Update.
	(name_to_index, number_to_index): Change return type to glyph_t.

	* src/include/printer.h (printer::set_char_and_width): Change return
	type to glyph_t.

	* src/libs/libdriver/printer.cpp (printer::set_char_and_width):
	Change return type to glyph_t.

	* src/devices/grodvi/dvi.cpp (dvi_printer::set_char): Change
	argument type to glyph_t.

	* src/devices/grohtml/post-html.cpp (page::add_and_encode): Update.
	(html_printer::space_glyph): Renamed from space_char_index.
	(html_printer::add_to_sbuf, html_printer::sbuf_continuation,
	html_printer::overstrike, html_printer::set_char): Change argument
	type to glyph_t.
	(html_printer::set_char_and_width): Change return type to glyph_t.

	* src/devices/grolbp/lbp.cpp (lbp_printer::set_char): Change
	argument type to glyph_t.

	* src/devices/grolj4/lj4.cpp (lj4_printer::set_char): Change
	argument type to glyph_t.

	* src/devices/grops/ps.cpp (ps_printer::space_glyph): Renamed from
	space_char_index.
	(ps_printer::set_subencoding, ps_printer::set_char): Change argument
	type to glyph_t.

	* src/devices/grotty/tty.cpp (tty_printer::set_char): Change
	argument type to glyph_t.

2006-02-11  Bruno Haible  <bruno@clisp.org>

	* src/roff/troff/input.cpp (font::name_to_index): Never return a
	negative value.

	* src/libs/libgroff/font.cpp (font::load): Remove failure tests for
	font::name_to_index.

2006-02-10  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo (Assigning Formats): Number registers are always
	interpolated.
	Apply some rephrasing, contributed by Michael Burt.

2006-02-07  Werner LEMBERG  <wl@gnu.org>

	* tmac/fr.tmac <ms>: Set `HY' register.

2006-02-07  Werner LEMBERG  <wl@gnu.org>

	Add framework for simple adaptation of the main macro packages (mm,
	me, ms, mom) to different locales.  In particular, add support for
	French.  For activation, simply use `-mfr' as the last macro
	package.  This feature has been contributed by Fabrice Ménard
	<menard.fabrice@wanadoo.fr>.

	* tmac/fr.tmac, tmac/trans.tmac, tmac/hyphen.fr, tmac/LOCALIZATION:
	New files.
	* tmac/README: Mention hyphen.fr.
	* man/groff_tmac.man: Mention fr.tmac.
	* NEWS: Updated.

2006-01-27  Werner LEMBERG  <wl@gnu.org>

	* man/groff_font.man: Updated documentation of `entity_name' field.
	Avoid future tense.

2006-01-27  Bruno Haible  <bruno@clisp.org>

	* font/devhtml/R.proto: Remove the entity names from the font's
	special_encoding_encoding column.
	* src/devices/grohtml/post-html.cpp (get_html_entity): New function,
	handling the entity names here.
	(get_html_translation): Use it.  Change return type to `const
	char *'.
	(page::add_and_encode): Update, removing a useless cast.

2006-01-26  Werner LEMBERG  <wl@gnu.org>

	This change is based on a patch by Bruno Haible <bruno@clisp.org>.

	* src/include/device.h: Add comments.
	* src/include/font.h: Add comments.
	* src/include/unicode.h: Likewise.
	* src/include/ptable.h, src/libs/libgroff/ptable.cpp: Likewise.

2006-01-26  Keith Marshall  <keith.d.marshall@ntlworld.com>

	Suppress `.st' request emission by `grn'.

	* src/preproc/grn/main.cpp (USE_ST_REQUEST): New macro.
	(conv): Use it.

2006-01-22  Werner LEMBERG  <wl@gnu.org>

	* install-sh: New version; taken from texinfo CVS.

2006-01-21  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/preconv/preconv.cpp (main): Set program_name.  Bug
	reported by Alexander E. Patrakov <patrakov@ums.usu.ru>.

2006-01-19  Bruno Haible  <bruno@clisp.org>

	Let `make -k install' install more files.

	* Makefile.in (MAKE_K_FLAG): New variable.  Use it everywhere where
	$(MAKE) and $(MDEFINES) are used.
	(CPROGDIRS): Remove $(XPROGDIRS).  Treat $(XPROGDIRS) like
	$(CPROGDIRS) everywhere.
	($(DEVDIRS) $(XDEVDIRS) $(OTHERDEVDIRS) $(TTYDEVDIRS)): Don't depend
	on $(XPROGDIRS).
	($(OTHERDIRS)): Likewise.


	* src/devices/grohtml/post-html.cpp (get_html_translation): Remove
	failure test for font::name_to_index -- it can never fail.

2006-01-19  Werner LEMBERG  <wl@gnu.org>

	* src/devices/grops/grops.man: Fix section on creating EPS files.
	Don't use future time in manual.
	Other minor fixes.

2006-01-15  Gaius Mulley  <gaius@glam.ac.uk>

	* tmac/www.tmac: New macro LINKSTYLE which allows users to set
	various typographical URL attributes for non-HTML devices.

	* tmac/groff_www.man: Document LINKSTYLE.

2006-01-11  Werner LEMBERG  <wl@gnu.org>

	* configure.ac: Test for getc_unlocked (needed for localcharset).
	* configure, src/include/config.hin: Regenerated.

	* src/libs/libgroff/Makefile.sub (EXTRA_CFLAGS): Define
	ENABLE_RELOCATABLE.

	* src/libs/libgroff/relocatable.h: New dummy header file for
	localcharset.c.

	* src/libs/libgroff/localcharset.c: Updated to (unchanged) CVS
	gnulib version.

2006-01-10  Bruno Haible  <bruno@clisp.org>

	Work around unportability of nl_langinfo(CODESET).

	* m4/glibc21.m4: New file, from gnulib.
	* Makefile.sub (M4MACROS): Add m4/glibc21.m4.
	* configure.ac: Also test for stddef.h, and invoke jm_GLIBC21.
	* Makefile.in (HOST, GLIBC21): New variables.
	(MDEFINES): Pass them to subdirectories.
	* src/include/relocate.h (relocatep): Define with C linkage.
	* src/include/localcharset.h: New file, from gnulib.
	* src/libs/libgroff/localcharset.c: New file, from gnulib with a
	modification for relocate().
	* src/libs/libgroff/config.charset: New file, from gnulib.
	* src/libs/libgroff/ref-add.sin: New file, from gnulib.
	* src/libs/libgroff/ref-del.sin: New file, from gnulib.
	* src/libs/libgroff/Makefile.sub (EXTRA_CFLAGS): Also define LIBDIR.
	(OBJS): Add localcharset.o.
	(CSRCS): Add localcharset.c.
	(all): Add dependencies to charset.alias, ref-add.sed, ref-del.sed.
	(charset.alias): New rule.
	(PACKAGE): New variable.
	(ref-add.sed, ref-del.sed): New rules.
	(MKINSTALLDIRS): New variable.
	(install_data): Depend on install_charset_data.
	(install_charset_data): New rule for creating or updating
	charset.alias.
	(uninstall_sub): Depend on uninstall_charset_data.
	(uninstall_charset_data): New rule for uninstalling or updating
	charset.alias.
	* src/preproc/preconv/preconv.cpp: Include localcharset.h instead
	of <langinfo.h>.
	(main): Initialize default_encoding from locale_charset() instead of
	nl_langinfo(CODESET).

	* aclocal.m4, configure, src/include/config.hin: Regenerated.

2006-01-10  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/preconv/preconv.cpp (conversion_iconv): Use
	ICONV_CONST in call to iconv.  Reported by Robert Goulding.

2006-01-07  Werner LEMBERG  <wl@gnu.org>

	* font/devps/generate/freeeuro.sfd: Run auto-hinter with recent
	fontforge version.
	Bump font version to 001.001.

	* font/devps/generate/Makefile (freeeuro.afm, freeeuro.pfa):
	Call fontforge, not pfaedit.

	* font/devps/freeeuro.afm, font/devps/freeeuro.pfa: Regenerated.

2006-01-05  Ruslan Ermilov  <ru@FreeBSD.org>

	* tmac/doc-common: Add new FreeBSD and NetBSD versions.
	* tmac/groff_mdoc.man: Updated.

2006-01-05  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/preconv/preconv.cpp: s/debug/debug_flag/.
	(raw_flag): New global variable.
	(do_file): Use .lf to set file name (if `raw_flag' isn't set).
	Don't pass BOM to `conversion_utf8'.
	(usage): Updated.
	(main): Handle `-r' command line switch to set `raw_flag'.
	(get_BOM): Fix encodings in `BOM_table'.

	* src/preproc/preconv/preconv.man: New file.  Not complete yet.
	* src/preproc/proconv/Makefile.sub (MAN1): New variable.

2006-01-04  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/preconv/preconv.cpp (emacs_to_mime): As suggested by
	Bruno, comment out most encodings to support only a small set of
	coding tags, thus reducing potential problems with legacy encodings
	and character sets in the future.
	Add many XEmacs coding tags (now commented out).
	Add `cp1047'.
	(check_encoding_tag): Renamed to...
	(check_coding_tag): This.
	(get_BOM): Return encoding as specified by BOM.
	Test for UTF32-LE too.
	(do_file): Don't check for coding tag if a BOM has been found.

2006-01-03  Bruno Haible  <bruno@clisp.org>

	* m4/groff.m4: Renamed from aclocal.m4.
	* m4/codeset.m4: New file, from gnulib.
	* m4/iconv.m4: New file, from gnulib.
	* m4/lib-ld.m4, m4/lib-link.m4, m4/lib-prefix.m4: New files, from
	gnulib.
	* config.rpath: New file, from gnulib.
	* config.guess, config.sub: New files, from gnulib.
	* Makefile.sub (M4MACROS): New variable.
	(configure): Fix typo.
	(aclocal.m4): New rule.
	(stamp-h.in): Depend on aclocal.m4.
	* configure.ac: Invoke AM_ICONV and AM_LANGINFO_CODESET.
	* Makefile.in (LIBICONV): New variable.
	(MDEFINES): Pass it to recursive makes.
	* src/preproc/preconv/preconv.cpp: Use HAVE_LANGINFO_CODESET and
	HAVE_ICONV instead of I18N macro.
	* src/preproc/preconv/Makefile.sub (EXTRA_LDFLAGS): New variable.

	* aclocal.m4, configure, src/include/config.hin: (Re)generated.

2006-01-03  Werner LEMBERG  <wl@gnu.org>

	* doc/Makefile.in (webpage.html): Simplify.
	* doc/Makefile.sub (webpage.html): Synchronize with doc/Makefile.in.
	* doc/webpage.ms, tmac/groff_www.man, tmac/www.tmac: Minor updates.

2006-01-01  Werner LEMBERG  <wl@gnu.org>

	* tmac/doc-common (Os): Add some Darwin versions.
	* tmac/groff_mdoc.man: Document them.

2006-01-01  Bruno Haible  <bruno@clisp.org>

	* src/preproc/preconv/preconv.cpp (emacs_to_mime): Various
	corrections:
	  . Don't map ascii to latin-1.
	  . Don't use IBMxxx encodings but cpxxx for portability.
	  . Map cp932, cp936, cp949, cp950 to itself.
	(emacs2mime): Protect calls to strcasecmp.
	(conversion_iconv): Add missing call to iconv_close.
	(do_file): Emit error message in case of unsupported encoding.

2005-12-31  Werner LEMBERG  <wl@gnu.org>

	Integrate preconv into the groff binary.  Changes based on a patch
	from Michail Vidiassov.

	* src/roff/groff/pipeline.h (MAX_COMMANDS): Increase by 1.

	* src/roff/groff/groff.cpp (PRECONV_INDEX): New macro.
	(SOELIM_INDEX): Updated.
	(help, synopsis): Updated.
	(main): Add command line options `-k' and `-K enc' to select
	encoding.
	Add support for GROFF_ENCODING environment variable.

	* src/roff/groff/groff.man: Updated and revised.


	Start with autoconf support for preconv.

	* configure.ac: Call AC_C_BIGENDIAN.
	* configure, src/include/config.hin: Regenerated.

2005-12-30  Werner LEMBERG  <wl@gnu.org>

	New preprocessor `preconv' to convert input encodings to something
	groff can understand.  Not yet integrated within groff.  Proper
	autoconf stuff is missing too.

	Tomohiro Kubota has written a first draft of this program, and some
	ideas have been reused (while almost no code has been taken
	actually).

	* src/preproc/preconv/preconv.cpp. src/preproc/preconv/Makefile.sub:
	New files.

	* MANIFEST, Makefile.in (CCPROGDIRS), test-groff.in
	(GROFF_BIN_PATH): Add preconv.

2005-12-12  Werner LEMBERG  <wl@gnu.org>

	* aclocal.m4 (GROFF_MAKEINFO): Fix regexps to be POSIX conformant.
	In particular, don't use `\+' since it is a GNU sed extension.

	* configure: Regenerated.

2005-12-09  Werner LEMBERG  <wl@gnu.org>

	* src/libs/libgroff/make-uniuni: New script to generate uniuni.cpp.

	* src/libs/libgroff/uniuni.cpp: Regenerated, using data from Unicode
	4.1.0.


	* src/utils/afmtodit/make-afmtodit-tables: New script to generate
	afmtodit.tables.

	* src/utils/afmtodit/afmtodit.tables: New file, representing Unicode
	4.1.0 data.

	* src/utils/afmtodit/afmtodit.pl (%unicode_decomposed,
	%AGL_to_unicode): Removed.  Replace it with a tag.

	* src/utils/afmtodit/Makefile.sub (afmtodit): Adjust sed expression
	to replace tag with actual file contents.

2005-12-08  Werner LEMBERG  <wl@gnu.org>

	The change 2005-06-20 can indeed cause problems, so we follow the
	advice by using marks.

	* font/devps/prologue.ps (PBEGIN): Use `mark'.
	(PEND): Use `cleartomark'.

2005-12-07  Michail Vidiassov  <master@iaas.msu.ru>

	* src/utils/afmtodit.pl: Fix kerning output to avoid warnings for
	glyphs which have kern values but aren't handled (glyph variants,
	for example).

2005-12-02  Werner LEMBERG  <wl@gnu.org>

	* src/devices/grops/ps.cpp (ps_printer::get_subfont): Use correct
	subfont index.  Reported by Michail Vidiassov <master@iaas.msu.ru>.

2005-11-28  Gaius Mulley  <gaius@glam.ac.uk>

	* doc/Makefile.in: Separate rule for webpage.html so that extra
	command line options can be passed to grohtml.
	* doc/groff.css: Change all margins to 0%.
	* doc/webpage.ms: Now use new macros ALN, LNS, and LNE so that left
	navigation is exploited.  Also update webpage to contain new
	sections on licenses, mailing lists, cvs/ftp access, groff
	dependencies, and bug reports.
	* tmac/groff_www.man: Document the new macros ALN, LNS, and LNE.
	* tmac/www.tmac: Implement the new macros ALN, LNS, and LNE.
	
2005-11-25  Gaius Mulley  <gaius@glam.ac.uk>

	* src/devices/grohtml/post-html.cpp
	(html_printer::do_file_components): Add fputs calls to emit the
	head contents and shut down the head tag whenever a new file
	component is generated.

2005-11-22  Gaius Mulley  <gaius@glam.ac.uk>

	* src/devices/grohtml/post-html.cpp (html_printer::flush_page): Add
	call to flush_text to flush any outstanding html tags on the
	paragraph stack.

2005-11-18  Werner LEMBERG  <wl@gnu.org>

	* aclocal.m4 (GROFF_MAKEINFO): Use `groff.info' in tests.
	Announce makeinfo version.
	* configure: Regenerated.

2005-11-18  Mike Frysinger <vapier@gentoo.org>

	* Makefile.in: Declare proper dependencies between make targets.

	* doc/Makefile.in: Rename groff info page to `groff.info'.
	* doc/Makefile.sub: Likewise.
	* doc/groff.texinfo: Likewise.

2005-11-17  Peter O'Gorman  <mlists@thewrittenword.com>

	* src/utils/pfbtops/pfbtops.c, src/utils/xtotroff/xtotroff.c: Move
	definition of __GETOPT_PREFIX to the beginning of file to ensure
	that it is defined even on platforms where getopt.h is already
	included by other header files.

2005-11-10  Gaius Mulley  <gaius@glam.ac.uk>

	* src/devices/grohtml/post-html.cpp (html_printer::do_heading):
	Reset font to NULL to ensure that a font block is recreated during
	the next paragraph.

2005-11-04  Werner LEMBERG  <wl@gnu.org>

	* aclocal.m4 (GROFF_MAKEINFO): Fix sed expression.
	* configure: Regenerated.

2005-10-27  Werner LEMBERG  <wl@gnu.org>

	* aclocal.m4 (GROFF_MAKEINFO): New function for checking whether
	makeinfo 4.8 or newer is available.
	* configure.ac: Call GROFF_MAKEINFO.
	* configure: Regenerated.

	* Makefile.in (MAKEINFO): Use autoconf variable.
	(MDEFINES): Add MAKEINFO.

	* doc/Makefile.in (MAKEINFO): Use autoconf variable.
	* doc/Makefile.sub (MAKEINFO): Remove.

2005-10-26  Werner LEMBERG  <wl@gnu.org>

	* REVISION: Set to 3.

2005-10-17  Werner LEMBERG  <wl@gnu.org>

	Mention $MANPAGER variable used with some `man' systems.

	* doc/webpage.ms, src/devices/grotty/grotty.man, NEWS: Updated.

2005-09-13  Werner LEMBERG  <wl@gnu.org>

	* tmac/hyphenex.us: New version (`ushyphex.tex' from ftp.dante.de).

Copyright 2005-2009 Free Software Foundation, Inc.

Copying and distribution of this file, with or without modification,
are permitted in any medium without royalty provided the copyright
notice and this notice are preserved.

Local Variables:
version-control: never
coding: latin-1
End:
